set_context dft -scan
read_verilog ../netlists/top.gate.v
read_cell_library ../libs/atpg.lib
analyze_control_signals -auto

// Go to DFT mode
set_system_mode analysis

// Insert scan chains
insert_test_logic -number 100
report_scan_chains

// Write netlist and setup files for ATPG
write_design -output_file ../netlists/gate_scan.v -replace
write_atpg_setup ./atpg -replace -procfile
exit
