set_context patterns -scan
read_verilog ../netlists/cpu_scan.v 
read_cell_library ../lib/atpglib
set_current_design cpu
// Read atpg setup
dofile atpg_setup.dofile 
// Go to atpg mode
set_system_mode analysis
// Pattern generation, default is stuck-at
create_patterns
// Save parallel and serial verilog patterns for simulation
write_patterns ../3_vsim/pat_stuck_par.v -verilog -parallel -replace
write_patterns ../3_vsim/pat_stuck_ser.v -verilog -begin 0 -end 2 -serial -rep
exit -d
