//
// Verilog format test patterns produced by Tessent Shell 2013.4
// Filename       : ../3_vsim/pat_stuck_par.v
// Scan operation : PARALLEL
// Idstamp        : 2013.4:9756:f974:423:da5c
// Fault          : STUCK
// Coverage       : 99.94(TC) 98.47(FC)
// Date           : Fri Dec 27 14:13:08 2013
//
// Begin_Verify_Section 
//   format            = Verilog 
//   top_module_name   = cpu_pat_stuck_par_v_ctl 
//   serial_flag       = OFF 
//   test_set_type     = ALL_TEST 
//   pad_value         = X 
//   pattern_begin     = 0 
//   pattern_end       = 422 
//   one_setup         = ON 
//   no_initialization = OFF 
//   pattern_checksum  = 2098812 
// End_Verify_Section 

`timescale 1ns / 1ns

module cpu_pat_stuck_par_v_ctl;

integer     _write_DIAG_file;
integer     _DIAG_file_header;
integer     _diag_file;
integer     _diag_chain_header;
integer     _diag_scan_header;
integer     _last_fail_pattern;
integer     _fail_pattern_cnt;
integer     _write_MASK_file;
integer     _MASK_file_header;
integer     _mask_file;
integer     _par_shift_cnt;
integer     _chain_test_;
integer     _compare_fail;
integer     _bit_count;
integer     _report_bit_cnt;
integer     _miscompare_limit;
integer     _found_fail;
integer     _end_vec_file_ok;
integer     _cycle_count, _save_cycle_count;
integer     _pattern_count, _repeat_count, _message_index;
integer     _index, _scan_index, _file_cnt, _max_index, _save_index;
integer     _file_check;
integer     _run_testsetup;
integer     _start_pat;
integer     _end_pat;
integer     _in_range;
integer     _do_compare;
integer     _in_chaintest;
integer     _pat_num;
integer     _skipped_patterns;
integer     _end_simulation;
integer     _config_file;
integer     _fstat;
integer     _max_file_cnt;
reg[256*8:1] _vec_file_name;
reg[83:0]    _ibus;
reg[148:0]    _exp_obus, _msk_obus;
wire[148:0]   _sim_obus;
reg[2:0]    _pat_type;
reg         _tp_num;
reg[458:0]   mem_vect;
reg[458:0]   vect;

wire \PORT0I[7] , \PORT0I[6] , \PORT0I[5] , \PORT0I[4] , \PORT0I[3] , 
     \PORT0I[2] , \PORT0I[1] , \PORT0I[0] , \PORT1I[7] , \PORT1I[6] , 
     \PORT1I[5] , \PORT1I[4] , \PORT1I[3] , \PORT1I[2] , \PORT1I[1] , 
     \PORT1I[0] , \PORT2I[7] , \PORT2I[6] , \PORT2I[5] , \PORT2I[4] , 
     \PORT2I[3] , \PORT2I[2] , \PORT2I[1] , \PORT2I[0] , \PORT3I[7] , 
     \PORT3I[6] , \PORT3I[5] , \PORT3I[4] , \PORT3I[3] , \PORT3I[2] , 
     \PORT3I[1] , \PORT3I[0] , \PROGDI[7] , \PROGDI[6] , \PROGDI[5] , 
     \PROGDI[4] , \PROGDI[3] , \PROGDI[2] , \PROGDI[1] , \PROGDI[0] , 
     \XRAMDI[7] , \XRAMDI[6] , \XRAMDI[5] , \XRAMDI[4] , \XRAMDI[3] , 
     \XRAMDI[2] , \XRAMDI[1] , \XRAMDI[0] , \SOURCE_DI[7] , \SOURCE_DI[6] , 
     \SOURCE_DI[5] , \SOURCE_DI[4] , \SOURCE_DI[3] , \SOURCE_DI[2] , 
     \SOURCE_DI[1] , \SOURCE_DI[0] , \ESFRDI[7] , \ESFRDI[6] , \ESFRDI[5] , 
     \ESFRDI[4] , \ESFRDI[3] , \ESFRDI[2] , \ESFRDI[1] , \ESFRDI[0] , 
     \XINTR_SRC[13] , \XINTR_SRC[12] , \XINTR_SRC[11] , \XINTR_SRC[10] , 
     \XINTR_SRC[9] , \XINTR_SRC[8] , \XINTR_SRC[7] , \XINTR_SRC[6] , 
     \XINTR_SRC[5] , MWAIT, CLK1, CLK2, CLK3, RESET, TRESET, scan_in1, 
     scan_in2, scan_in3, scan_in4, scan_en, \PORT0O[7] , \PORT0O[6] , 
     \PORT0O[5] , \PORT0O[4] , \PORT0O[3] , \PORT0O[2] , \PORT0O[1] , 
     \PORT0O[0] , \PORT1O[7] , \PORT1O[6] , \PORT1O[5] , \PORT1O[4] , 
     \PORT1O[3] , \PORT1O[2] , \PORT1O[1] , \PORT1O[0] , \PORT2O[7] , 
     \PORT2O[6] , \PORT2O[5] , \PORT2O[4] , \PORT2O[3] , \PORT2O[2] , 
     \PORT2O[1] , \PORT2O[0] , \PORT3O[7] , \PORT3O[6] , \PORT3O[5] , 
     \PORT3O[4] , \PORT3O[3] , \PORT3O[2] , \PORT3O[1] , \PORT3O[0] , 
     \NPORT1E[7] , \NPORT1E[6] , \NPORT1E[5] , \NPORT1E[4] , \NPORT1E[3] , 
     \NPORT1E[2] , \NPORT1E[1] , \NPORT1E[0] , \NPORT2E[7] , \NPORT2E[6] , 
     \NPORT2E[5] , \NPORT2E[4] , \NPORT2E[3] , \NPORT2E[2] , \NPORT2E[1] , 
     \NPORT2E[0] , \NPORT3E[7] , \NPORT3E[6] , \NPORT3E[5] , \NPORT3E[4] , 
     \NPORT3E[3] , \NPORT3E[2] , \NPORT3E[1] , \NPORT3E[0] , \XRAMDO[7] , 
     \XRAMDO[6] , \XRAMDO[5] , \XRAMDO[4] , \XRAMDO[3] , \XRAMDO[2] , 
     \XRAMDO[1] , \XRAMDO[0] , \PROGA[15] , \PROGA[14] , \PROGA[13] , 
     \PROGA[12] , \PROGA[11] , \PROGA[10] , \PROGA[9] , \PROGA[8] , 
     \PROGA[7] , \PROGA[6] , \PROGA[5] , \PROGA[4] , \PROGA[3] , \PROGA[2] , 
     \PROGA[1] , \PROGA[0] , \XRAMA[15] , \XRAMA[14] , \XRAMA[13] , 
     \XRAMA[12] , \XRAMA[11] , \XRAMA[10] , \XRAMA[9] , \XRAMA[8] , 
     \XRAMA[7] , \XRAMA[6] , \XRAMA[5] , \XRAMA[4] , \XRAMA[3] , \XRAMA[2] , 
     \XRAMA[1] , \XRAMA[0] , NPSEN, NXRAMR, NXRAMW, PROGA_EN, XRAMA_EN, 
     \SOURCE_A[7] , \SOURCE_A[6] , \SOURCE_A[5] , \SOURCE_A[4] , \SOURCE_A[3] , 
     \SOURCE_A[2] , \SOURCE_A[1] , \SOURCE_A[0] , \DESTIN_A[7] , \DESTIN_A[6] , 
     \DESTIN_A[5] , \DESTIN_A[4] , \DESTIN_A[3] , \DESTIN_A[2] , \DESTIN_A[1] , 
     \DESTIN_A[0] , \DESTIN_DO[7] , \DESTIN_DO[6] , \DESTIN_DO[5] , 
     \DESTIN_DO[4] , \DESTIN_DO[3] , \DESTIN_DO[2] , \DESTIN_DO[1] , 
     \DESTIN_DO[0] , NDESTIN_WE, NSOURCE_RE, SFRWE, \SFRSA[6] , \SFRSA[5] , 
     \SFRSA[4] , \SFRSA[3] , \SFRSA[2] , \SFRSA[1] , \SFRSA[0] , \XINTR_ACK[13] , 
     \XINTR_ACK[12] , \XINTR_ACK[11] , \XINTR_ACK[10] , \XINTR_ACK[9] , 
     \XINTR_ACK[8] , \XINTR_ACK[7] , \XINTR_ACK[6] , \XINTR_ACK[5] , 
     IDLE, PDOWN, NCCLKE, NPCLKE, scan_out1;

assign \PORT0I[7]  = _ibus[83];
assign \PORT0I[6]  = _ibus[82];
assign \PORT0I[5]  = _ibus[81];
assign \PORT0I[4]  = _ibus[80];
assign \PORT0I[3]  = _ibus[79];
assign \PORT0I[2]  = _ibus[78];
assign \PORT0I[1]  = _ibus[77];
assign \PORT0I[0]  = _ibus[76];
assign \PORT1I[7]  = _ibus[75];
assign \PORT1I[6]  = _ibus[74];
assign \PORT1I[5]  = _ibus[73];
assign \PORT1I[4]  = _ibus[72];
assign \PORT1I[3]  = _ibus[71];
assign \PORT1I[2]  = _ibus[70];
assign \PORT1I[1]  = _ibus[69];
assign \PORT1I[0]  = _ibus[68];
assign \PORT2I[7]  = _ibus[67];
assign \PORT2I[6]  = _ibus[66];
assign \PORT2I[5]  = _ibus[65];
assign \PORT2I[4]  = _ibus[64];
assign \PORT2I[3]  = _ibus[63];
assign \PORT2I[2]  = _ibus[62];
assign \PORT2I[1]  = _ibus[61];
assign \PORT2I[0]  = _ibus[60];
assign \PORT3I[7]  = _ibus[59];
assign \PORT3I[6]  = _ibus[58];
assign \PORT3I[5]  = _ibus[57];
assign \PORT3I[4]  = _ibus[56];
assign \PORT3I[3]  = _ibus[55];
assign \PORT3I[2]  = _ibus[54];
assign \PORT3I[1]  = _ibus[53];
assign \PORT3I[0]  = _ibus[52];
assign \PROGDI[7]  = _ibus[51];
assign \PROGDI[6]  = _ibus[50];
assign \PROGDI[5]  = _ibus[49];
assign \PROGDI[4]  = _ibus[48];
assign \PROGDI[3]  = _ibus[47];
assign \PROGDI[2]  = _ibus[46];
assign \PROGDI[1]  = _ibus[45];
assign \PROGDI[0]  = _ibus[44];
assign \XRAMDI[7]  = _ibus[43];
assign \XRAMDI[6]  = _ibus[42];
assign \XRAMDI[5]  = _ibus[41];
assign \XRAMDI[4]  = _ibus[40];
assign \XRAMDI[3]  = _ibus[39];
assign \XRAMDI[2]  = _ibus[38];
assign \XRAMDI[1]  = _ibus[37];
assign \XRAMDI[0]  = _ibus[36];
assign \SOURCE_DI[7]  = _ibus[35];
assign \SOURCE_DI[6]  = _ibus[34];
assign \SOURCE_DI[5]  = _ibus[33];
assign \SOURCE_DI[4]  = _ibus[32];
assign \SOURCE_DI[3]  = _ibus[31];
assign \SOURCE_DI[2]  = _ibus[30];
assign \SOURCE_DI[1]  = _ibus[29];
assign \SOURCE_DI[0]  = _ibus[28];
assign \ESFRDI[7]  = _ibus[27];
assign \ESFRDI[6]  = _ibus[26];
assign \ESFRDI[5]  = _ibus[25];
assign \ESFRDI[4]  = _ibus[24];
assign \ESFRDI[3]  = _ibus[23];
assign \ESFRDI[2]  = _ibus[22];
assign \ESFRDI[1]  = _ibus[21];
assign \ESFRDI[0]  = _ibus[20];
assign \XINTR_SRC[13]  = _ibus[19];
assign \XINTR_SRC[12]  = _ibus[18];
assign \XINTR_SRC[11]  = _ibus[17];
assign \XINTR_SRC[10]  = _ibus[16];
assign \XINTR_SRC[9]  = _ibus[15];
assign \XINTR_SRC[8]  = _ibus[14];
assign \XINTR_SRC[7]  = _ibus[13];
assign \XINTR_SRC[6]  = _ibus[12];
assign \XINTR_SRC[5]  = _ibus[11];
assign MWAIT = _ibus[10];
assign CLK1 = _ibus[9];
assign CLK2 = _ibus[8];
assign CLK3 = _ibus[7];
assign RESET = _ibus[6];
assign TRESET = _ibus[5];
assign scan_in1 = _ibus[4];
assign scan_in2 = _ibus[3];
assign scan_in3 = _ibus[2];
assign scan_in4 = _ibus[1];
assign scan_en = _ibus[0];

assign _sim_obus[148] = \PORT0O[7] ;
assign _sim_obus[147] = \PORT0O[6] ;
assign _sim_obus[146] = \PORT0O[5] ;
assign _sim_obus[145] = \PORT0O[4] ;
assign _sim_obus[144] = \PORT0O[3] ;
assign _sim_obus[143] = \PORT0O[2] ;
assign _sim_obus[142] = \PORT0O[1] ;
assign _sim_obus[141] = \PORT0O[0] ;
assign _sim_obus[140] = \PORT1O[7] ;
assign _sim_obus[139] = \PORT1O[6] ;
assign _sim_obus[138] = \PORT1O[5] ;
assign _sim_obus[137] = \PORT1O[4] ;
assign _sim_obus[136] = \PORT1O[3] ;
assign _sim_obus[135] = \PORT1O[2] ;
assign _sim_obus[134] = \PORT1O[1] ;
assign _sim_obus[133] = \PORT1O[0] ;
assign _sim_obus[132] = \PORT2O[7] ;
assign _sim_obus[131] = \PORT2O[6] ;
assign _sim_obus[130] = \PORT2O[5] ;
assign _sim_obus[129] = \PORT2O[4] ;
assign _sim_obus[128] = \PORT2O[3] ;
assign _sim_obus[127] = \PORT2O[2] ;
assign _sim_obus[126] = \PORT2O[1] ;
assign _sim_obus[125] = \PORT2O[0] ;
assign _sim_obus[124] = \PORT3O[7] ;
assign _sim_obus[123] = \PORT3O[6] ;
assign _sim_obus[122] = \PORT3O[5] ;
assign _sim_obus[121] = \PORT3O[4] ;
assign _sim_obus[120] = \PORT3O[3] ;
assign _sim_obus[119] = \PORT3O[2] ;
assign _sim_obus[118] = \PORT3O[1] ;
assign _sim_obus[117] = \PORT3O[0] ;
assign _sim_obus[116] = \NPORT1E[7] ;
assign _sim_obus[115] = \NPORT1E[6] ;
assign _sim_obus[114] = \NPORT1E[5] ;
assign _sim_obus[113] = \NPORT1E[4] ;
assign _sim_obus[112] = \NPORT1E[3] ;
assign _sim_obus[111] = \NPORT1E[2] ;
assign _sim_obus[110] = \NPORT1E[1] ;
assign _sim_obus[109] = \NPORT1E[0] ;
assign _sim_obus[108] = \NPORT2E[7] ;
assign _sim_obus[107] = \NPORT2E[6] ;
assign _sim_obus[106] = \NPORT2E[5] ;
assign _sim_obus[105] = \NPORT2E[4] ;
assign _sim_obus[104] = \NPORT2E[3] ;
assign _sim_obus[103] = \NPORT2E[2] ;
assign _sim_obus[102] = \NPORT2E[1] ;
assign _sim_obus[101] = \NPORT2E[0] ;
assign _sim_obus[100] = \NPORT3E[7] ;
assign _sim_obus[99] = \NPORT3E[6] ;
assign _sim_obus[98] = \NPORT3E[5] ;
assign _sim_obus[97] = \NPORT3E[4] ;
assign _sim_obus[96] = \NPORT3E[3] ;
assign _sim_obus[95] = \NPORT3E[2] ;
assign _sim_obus[94] = \NPORT3E[1] ;
assign _sim_obus[93] = \NPORT3E[0] ;
assign _sim_obus[92] = \XRAMDO[7] ;
assign _sim_obus[91] = \XRAMDO[6] ;
assign _sim_obus[90] = \XRAMDO[5] ;
assign _sim_obus[89] = \XRAMDO[4] ;
assign _sim_obus[88] = \XRAMDO[3] ;
assign _sim_obus[87] = \XRAMDO[2] ;
assign _sim_obus[86] = \XRAMDO[1] ;
assign _sim_obus[85] = \XRAMDO[0] ;
assign _sim_obus[84] = \PROGA[15] ;
assign _sim_obus[83] = \PROGA[14] ;
assign _sim_obus[82] = \PROGA[13] ;
assign _sim_obus[81] = \PROGA[12] ;
assign _sim_obus[80] = \PROGA[11] ;
assign _sim_obus[79] = \PROGA[10] ;
assign _sim_obus[78] = \PROGA[9] ;
assign _sim_obus[77] = \PROGA[8] ;
assign _sim_obus[76] = \PROGA[7] ;
assign _sim_obus[75] = \PROGA[6] ;
assign _sim_obus[74] = \PROGA[5] ;
assign _sim_obus[73] = \PROGA[4] ;
assign _sim_obus[72] = \PROGA[3] ;
assign _sim_obus[71] = \PROGA[2] ;
assign _sim_obus[70] = \PROGA[1] ;
assign _sim_obus[69] = \PROGA[0] ;
assign _sim_obus[68] = \XRAMA[15] ;
assign _sim_obus[67] = \XRAMA[14] ;
assign _sim_obus[66] = \XRAMA[13] ;
assign _sim_obus[65] = \XRAMA[12] ;
assign _sim_obus[64] = \XRAMA[11] ;
assign _sim_obus[63] = \XRAMA[10] ;
assign _sim_obus[62] = \XRAMA[9] ;
assign _sim_obus[61] = \XRAMA[8] ;
assign _sim_obus[60] = \XRAMA[7] ;
assign _sim_obus[59] = \XRAMA[6] ;
assign _sim_obus[58] = \XRAMA[5] ;
assign _sim_obus[57] = \XRAMA[4] ;
assign _sim_obus[56] = \XRAMA[3] ;
assign _sim_obus[55] = \XRAMA[2] ;
assign _sim_obus[54] = \XRAMA[1] ;
assign _sim_obus[53] = \XRAMA[0] ;
assign _sim_obus[52] = NPSEN;
assign _sim_obus[51] = NXRAMR;
assign _sim_obus[50] = NXRAMW;
assign _sim_obus[49] = PROGA_EN;
assign _sim_obus[48] = XRAMA_EN;
assign _sim_obus[47] = \SOURCE_A[7] ;
assign _sim_obus[46] = \SOURCE_A[6] ;
assign _sim_obus[45] = \SOURCE_A[5] ;
assign _sim_obus[44] = \SOURCE_A[4] ;
assign _sim_obus[43] = \SOURCE_A[3] ;
assign _sim_obus[42] = \SOURCE_A[2] ;
assign _sim_obus[41] = \SOURCE_A[1] ;
assign _sim_obus[40] = \SOURCE_A[0] ;
assign _sim_obus[39] = \DESTIN_A[7] ;
assign _sim_obus[38] = \DESTIN_A[6] ;
assign _sim_obus[37] = \DESTIN_A[5] ;
assign _sim_obus[36] = \DESTIN_A[4] ;
assign _sim_obus[35] = \DESTIN_A[3] ;
assign _sim_obus[34] = \DESTIN_A[2] ;
assign _sim_obus[33] = \DESTIN_A[1] ;
assign _sim_obus[32] = \DESTIN_A[0] ;
assign _sim_obus[31] = \DESTIN_DO[7] ;
assign _sim_obus[30] = \DESTIN_DO[6] ;
assign _sim_obus[29] = \DESTIN_DO[5] ;
assign _sim_obus[28] = \DESTIN_DO[4] ;
assign _sim_obus[27] = \DESTIN_DO[3] ;
assign _sim_obus[26] = \DESTIN_DO[2] ;
assign _sim_obus[25] = \DESTIN_DO[1] ;
assign _sim_obus[24] = \DESTIN_DO[0] ;
assign _sim_obus[23] = NDESTIN_WE;
assign _sim_obus[22] = NSOURCE_RE;
assign _sim_obus[21] = SFRWE;
assign _sim_obus[20] = \SFRSA[6] ;
assign _sim_obus[19] = \SFRSA[5] ;
assign _sim_obus[18] = \SFRSA[4] ;
assign _sim_obus[17] = \SFRSA[3] ;
assign _sim_obus[16] = \SFRSA[2] ;
assign _sim_obus[15] = \SFRSA[1] ;
assign _sim_obus[14] = \SFRSA[0] ;
assign _sim_obus[13] = \XINTR_ACK[13] ;
assign _sim_obus[12] = \XINTR_ACK[12] ;
assign _sim_obus[11] = \XINTR_ACK[11] ;
assign _sim_obus[10] = \XINTR_ACK[10] ;
assign _sim_obus[9] = \XINTR_ACK[9] ;
assign _sim_obus[8] = \XINTR_ACK[8] ;
assign _sim_obus[7] = \XINTR_ACK[7] ;
assign _sim_obus[6] = \XINTR_ACK[6] ;
assign _sim_obus[5] = \XINTR_ACK[5] ;
assign _sim_obus[4] = IDLE;
assign _sim_obus[3] = PDOWN;
assign _sim_obus[2] = NCCLKE;
assign _sim_obus[1] = NPCLKE;
assign _sim_obus[0] = scan_out1;

reg[256*8:1]  _tmp_filename; 
reg[256*8:1]  _new_filename; 

reg [119:0] _nam_obus[148:0];
initial $readmemh("pat_stuck_par.v.po.name",_nam_obus,148,0);


// Declare Wires for tracking Vector Type
reg[3:0] _MGCDFT_VECTYPE ;
reg mgcdft_test_setup, mgcdft_load_unload, mgcdft_shift,
     mgcdft_single_shift, mgcdft_shift_extra, 
     mgcdft_shadow_control, mgcdft_master_observe,
     mgcdft_shadow_observe, mgcdft_skew_load, 
     mgcdft_seq_transparent, mgcdft_launch_capture,
     mgcdft_clock_proc, mgcdft_test_end, mgcdft_unknown; 

event       set_vector_type;
always @(_MGCDFT_VECTYPE) begin
  assign mgcdft_test_setup      = 1'b0;
  assign mgcdft_load_unload     = 1'b0;
  assign mgcdft_shift           = 1'b0;
  assign mgcdft_single_shift    = 1'b0;
  assign mgcdft_shift_extra     = 1'b0;
  assign mgcdft_shadow_control  = 1'b0;
  assign mgcdft_master_observe  = 1'b0;
  assign mgcdft_shadow_observe  = 1'b0;
  assign mgcdft_skew_load       = 1'b0;
  assign mgcdft_seq_transparent = 1'b0;
  assign mgcdft_launch_capture  = 1'b0;
  assign mgcdft_clock_proc      = 1'b0;
  assign mgcdft_test_end        = 1'b0;
  assign mgcdft_unknown         = 1'b0;
  case (_MGCDFT_VECTYPE)
    4'b0001: begin
               assign mgcdft_test_setup      = 1'b1;
             end
    4'b0010: begin
               assign mgcdft_load_unload     = 1'b1;
             end
    4'b0011: begin
               assign mgcdft_shift           = 1'b1;
             end
    4'b0100: begin
               assign mgcdft_single_shift    = 1'b1;
             end
    4'b0101: begin
               assign mgcdft_shift_extra     = 1'b1;
             end
    4'b0110: begin
               assign mgcdft_shadow_control  = 1'b1;
             end
    4'b0111: begin
               assign mgcdft_master_observe  = 1'b1;
             end
    4'b1000: begin
               assign mgcdft_shadow_observe  = 1'b1;
             end
    4'b1001: begin
               assign mgcdft_skew_load       = 1'b1;
             end
    4'b1010: begin
               assign mgcdft_seq_transparent = 1'b1;
             end
    4'b1011: begin
               assign mgcdft_launch_capture  = 1'b1;
             end
    4'b1101: begin
               assign mgcdft_clock_proc      = 1'b1;
             end
    4'b1111: begin
               assign mgcdft_test_end        = 1'b1;
             end
    4'b0000: begin
               assign mgcdft_unknown         = 1'b1;
             end
    default: begin
               assign mgcdft_unknown         = 1'b1;
             end
  endcase
end

event       compare_exp_sim_obus;
always @(compare_exp_sim_obus) begin
 _found_fail = 0;
 if (_do_compare) begin
  if (_exp_obus !== _sim_obus) begin
     for(_bit_count = 0;
         ((_bit_count < 149)&&(_found_fail==0));
          _bit_count =_bit_count +1) begin
        if ((_msk_obus[_bit_count] === 1'b1) &&
            (_exp_obus[_bit_count] !== _sim_obus[_bit_count])) begin
           _found_fail = 1;
        end
     end
  end
  if (_found_fail == 1) begin
    $write($time, "ns: Simulated response %b pattern %d cycle %d\n",_sim_obus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response %b pattern %d cycle %d\n",_exp_obus,_pattern_count,_cycle_count);
     for(_bit_count = 0;
         ((_bit_count < 149)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
          _bit_count =_bit_count +1) begin
      if ((_msk_obus[_bit_count] === 1'b1) &&
          (_exp_obus[_bit_count] !== _sim_obus[_bit_count])) begin
        $write($time, "ns: Mismatch at pin %d name %s, Simulated %b, Expected %b\n",_bit_count,_nam_obus[_bit_count],_sim_obus[_bit_count],_exp_obus[_bit_count]);
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_par.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_par.v)\n");
            $fwrite(_diag_file, "//format pattern\n");
            $fwrite(_diag_file, "//failure_buffer_limit_reached none\n");
            $fwrite(_diag_file, "//data_reference cell\n");
            $fwrite(_diag_file, "//pattern_id      chain/PO_name   cell_number   expected_value   simulated_value\n\n");
            _DIAG_file_header = 1;
          end
          if ((_chain_test_)&&(_diag_chain_header!=1)) begin
            $fwrite(_diag_file, "chain_test\n");
            _diag_chain_header = 1;
          end
          if ((_chain_test_!=1)&&(_diag_scan_header!=1)) begin
            $fwrite(_diag_file, "scan_test\n");
            _diag_scan_header = 1;
          end
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin
             _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          $fwrite(_diag_file, "%d  %s ", _pattern_count, _nam_obus[_bit_count]);
          case ( _exp_obus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, "            H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, "            L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, "            Z"); 
                  end
          endcase
          case ( _sim_obus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // PO\n"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // PO\n"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // PO\n"); 
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // PO\n"); 
                  end
          endcase
        end // EndIf _write_DIAG_file
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_par.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
          if (_chain_test_ == 0) begin
            $fwrite(_mask_file, "%d %s\n", _pattern_count,_nam_obus[_bit_count]);
          end
          if (_chain_test_ == 1) begin
            $fwrite(_mask_file, "// %d %s\n", _pattern_count,_nam_obus[_bit_count]);
          end
        end
      end
    end
    _compare_fail = _compare_fail + 1;
  end
 end // if _do_compare
end

reg[100:0]    _exp_chain1_sobus, _msk_chain1_sobus, _frc_chain1_sibus;
wire[100:0]   _sim_chain1_sobus;

event  force_frc_chain1_sibus;
always @(force_frc_chain1_sibus) begin
force  {cpu_inst.uPDR.ix700.SI , cpu_inst.uPDR.ix630.SI , cpu_inst.uPDR.ix640.SI , 
     cpu_inst.uPDR.ix650.SI , cpu_inst.uPDR.ix660.SI , cpu_inst.uPDR.ix670.SI , 
     cpu_inst.uPDR.ix680.SI , cpu_inst.uPDR.ix690.SI , cpu_inst.uCNTR.ix1003.SI , 
     cpu_inst.uCNTR.ix1053.SI , cpu_inst.uCNTR.ix1103.SI , cpu_inst.uCNTR.ix1113.SI , 
     cpu_inst.uCNTR.ix1163.SI , cpu_inst.uCNTR.ix1173.SI , cpu_inst.uCNTR.ix1063.SI , 
     cpu_inst.uCNTR.ix1013.SI , cpu_inst.uCNTR.ix1183.SI , cpu_inst.uCNTR.ix1123.SI , 
     cpu_inst.uCNTR.uTH0.ix134.SI , cpu_inst.uCNTR.uTH0.ix64.SI , cpu_inst.uCNTR.uTH0.ix74.SI , 
     cpu_inst.uCNTR.uTH0.ix84.SI , cpu_inst.uCNTR.uTH0.ix94.SI , cpu_inst.uCNTR.uTH0.ix104.SI , 
     cpu_inst.uCNTR.uTH0.ix114.SI , cpu_inst.uCNTR.uTH0.ix124.SI , cpu_inst.uCNTR.uTL1.ix447.SI , 
     cpu_inst.uCNTR.uTL1.ix377.SI , cpu_inst.uCNTR.uTL1.ix387.SI , cpu_inst.uCNTR.uTL1.ix397.SI , 
     cpu_inst.uCNTR.uTL1.ix407.SI , cpu_inst.uCNTR.uTL1.ix417.SI , cpu_inst.uCNTR.uTL1.ix427.SI , 
     cpu_inst.uCNTR.uTL1.ix437.SI , cpu_inst.uCNTR.uTH1.ix134.SI , cpu_inst.uCNTR.uTH1.ix64.SI , 
     cpu_inst.uCNTR.uTH1.ix74.SI , cpu_inst.uCNTR.uTH1.ix84.SI , cpu_inst.uCNTR.uTH1.ix94.SI , 
     cpu_inst.uCNTR.uTH1.ix104.SI , cpu_inst.uCNTR.uTH1.ix114.SI , cpu_inst.uCNTR.uTH1.ix124.SI , 
     cpu_inst.uCNTR.uTL0.ix447.SI , cpu_inst.uCNTR.uTL0.ix377.SI , cpu_inst.uCNTR.uTL0.ix387.SI , 
     cpu_inst.uCNTR.uTL0.ix397.SI , cpu_inst.uCNTR.uTL0.ix407.SI , cpu_inst.uCNTR.uTL0.ix417.SI , 
     cpu_inst.uCNTR.uTL0.ix427.SI , cpu_inst.uCNTR.uTL0.ix437.SI , cpu_inst.uUART.ix2531.SI , 
     cpu_inst.uUART.ix2521.SI , cpu_inst.uUART.ix2511.SI , cpu_inst.uUART.ix2251.SI , 
     cpu_inst.uUART.ix2241.SI , cpu_inst.uUART.ix2231.SI , cpu_inst.uUART.ix2221.SI , 
     cpu_inst.uUART.ix2211.SI , cpu_inst.uUART.ix2201.SI , cpu_inst.uUART.ix2191.SI , 
     cpu_inst.uUART.ix2181.SI , cpu_inst.uUART.ix2161.SI , cpu_inst.uUART.ix2151.SI , 
     cpu_inst.uUART.ix2101.SI , cpu_inst.uUART.ix2111.SI , cpu_inst.uUART.ix2121.SI , 
     cpu_inst.uUART.ix2141.SI , cpu_inst.uUART.ix2131.SI , cpu_inst.uUART.ix2261.SI , 
     cpu_inst.uUART.ix2541.SI , cpu_inst.uUART.ix2351.SI , cpu_inst.uUART.ix2291.SI , 
     cpu_inst.uUART.ix2281.SI , cpu_inst.uUART.ix2501.SI , cpu_inst.uUART.ix2481.SI , 
     cpu_inst.uUART.ix2391.SI , cpu_inst.uUART.ix2371.SI , cpu_inst.uUART.ix2331.SI , 
     cpu_inst.uUART.ix2311.SI , cpu_inst.uUART.ix2321.SI , cpu_inst.uUART.ix2341.SI , 
     cpu_inst.uUART.ix2381.SI , cpu_inst.uUART.ix2361.SI , cpu_inst.uUART.ix2471.SI , 
     cpu_inst.uUART.ix2461.SI , cpu_inst.uUART.ix2451.SI , cpu_inst.uUART.ix2441.SI , 
     cpu_inst.uUART.ix2431.SI , cpu_inst.uUART.ix2421.SI , cpu_inst.uUART.ix2411.SI , 
     cpu_inst.uUART.ix2401.SI , cpu_inst.uUART.ix2271.SI , cpu_inst.uUART.ix2551.SI , 
     cpu_inst.uUART.ix2561.SI , cpu_inst.uUART.ix2581.SI , cpu_inst.uUART.ix2571.SI , 
     cpu_inst.uUART.ix2591.SI , cpu_inst.uUART.ix2601.SI , cpu_inst.uUART.ix2611.SI , 
     cpu_inst.uUART.ix2621.SI , cpu_inst.uUART.ix2631.SI  } = _frc_chain1_sibus[100:0];
end


event release_frc_chain1_sibus;
always @(release_frc_chain1_sibus) begin
release  {cpu_inst.uPDR.ix700.SI , cpu_inst.uPDR.ix630.SI , cpu_inst.uPDR.ix640.SI , 
     cpu_inst.uPDR.ix650.SI , cpu_inst.uPDR.ix660.SI , cpu_inst.uPDR.ix670.SI , 
     cpu_inst.uPDR.ix680.SI , cpu_inst.uPDR.ix690.SI , cpu_inst.uCNTR.ix1003.SI , 
     cpu_inst.uCNTR.ix1053.SI , cpu_inst.uCNTR.ix1103.SI , cpu_inst.uCNTR.ix1113.SI , 
     cpu_inst.uCNTR.ix1163.SI , cpu_inst.uCNTR.ix1173.SI , cpu_inst.uCNTR.ix1063.SI , 
     cpu_inst.uCNTR.ix1013.SI , cpu_inst.uCNTR.ix1183.SI , cpu_inst.uCNTR.ix1123.SI , 
     cpu_inst.uCNTR.uTH0.ix134.SI , cpu_inst.uCNTR.uTH0.ix64.SI , cpu_inst.uCNTR.uTH0.ix74.SI , 
     cpu_inst.uCNTR.uTH0.ix84.SI , cpu_inst.uCNTR.uTH0.ix94.SI , cpu_inst.uCNTR.uTH0.ix104.SI , 
     cpu_inst.uCNTR.uTH0.ix114.SI , cpu_inst.uCNTR.uTH0.ix124.SI , cpu_inst.uCNTR.uTL1.ix447.SI , 
     cpu_inst.uCNTR.uTL1.ix377.SI , cpu_inst.uCNTR.uTL1.ix387.SI , cpu_inst.uCNTR.uTL1.ix397.SI , 
     cpu_inst.uCNTR.uTL1.ix407.SI , cpu_inst.uCNTR.uTL1.ix417.SI , cpu_inst.uCNTR.uTL1.ix427.SI , 
     cpu_inst.uCNTR.uTL1.ix437.SI , cpu_inst.uCNTR.uTH1.ix134.SI , cpu_inst.uCNTR.uTH1.ix64.SI , 
     cpu_inst.uCNTR.uTH1.ix74.SI , cpu_inst.uCNTR.uTH1.ix84.SI , cpu_inst.uCNTR.uTH1.ix94.SI , 
     cpu_inst.uCNTR.uTH1.ix104.SI , cpu_inst.uCNTR.uTH1.ix114.SI , cpu_inst.uCNTR.uTH1.ix124.SI , 
     cpu_inst.uCNTR.uTL0.ix447.SI , cpu_inst.uCNTR.uTL0.ix377.SI , cpu_inst.uCNTR.uTL0.ix387.SI , 
     cpu_inst.uCNTR.uTL0.ix397.SI , cpu_inst.uCNTR.uTL0.ix407.SI , cpu_inst.uCNTR.uTL0.ix417.SI , 
     cpu_inst.uCNTR.uTL0.ix427.SI , cpu_inst.uCNTR.uTL0.ix437.SI , cpu_inst.uUART.ix2531.SI , 
     cpu_inst.uUART.ix2521.SI , cpu_inst.uUART.ix2511.SI , cpu_inst.uUART.ix2251.SI , 
     cpu_inst.uUART.ix2241.SI , cpu_inst.uUART.ix2231.SI , cpu_inst.uUART.ix2221.SI , 
     cpu_inst.uUART.ix2211.SI , cpu_inst.uUART.ix2201.SI , cpu_inst.uUART.ix2191.SI , 
     cpu_inst.uUART.ix2181.SI , cpu_inst.uUART.ix2161.SI , cpu_inst.uUART.ix2151.SI , 
     cpu_inst.uUART.ix2101.SI , cpu_inst.uUART.ix2111.SI , cpu_inst.uUART.ix2121.SI , 
     cpu_inst.uUART.ix2141.SI , cpu_inst.uUART.ix2131.SI , cpu_inst.uUART.ix2261.SI , 
     cpu_inst.uUART.ix2541.SI , cpu_inst.uUART.ix2351.SI , cpu_inst.uUART.ix2291.SI , 
     cpu_inst.uUART.ix2281.SI , cpu_inst.uUART.ix2501.SI , cpu_inst.uUART.ix2481.SI , 
     cpu_inst.uUART.ix2391.SI , cpu_inst.uUART.ix2371.SI , cpu_inst.uUART.ix2331.SI , 
     cpu_inst.uUART.ix2311.SI , cpu_inst.uUART.ix2321.SI , cpu_inst.uUART.ix2341.SI , 
     cpu_inst.uUART.ix2381.SI , cpu_inst.uUART.ix2361.SI , cpu_inst.uUART.ix2471.SI , 
     cpu_inst.uUART.ix2461.SI , cpu_inst.uUART.ix2451.SI , cpu_inst.uUART.ix2441.SI , 
     cpu_inst.uUART.ix2431.SI , cpu_inst.uUART.ix2421.SI , cpu_inst.uUART.ix2411.SI , 
     cpu_inst.uUART.ix2401.SI , cpu_inst.uUART.ix2271.SI , cpu_inst.uUART.ix2551.SI , 
     cpu_inst.uUART.ix2561.SI , cpu_inst.uUART.ix2581.SI , cpu_inst.uUART.ix2571.SI , 
     cpu_inst.uUART.ix2591.SI , cpu_inst.uUART.ix2601.SI , cpu_inst.uUART.ix2611.SI , 
     cpu_inst.uUART.ix2621.SI , cpu_inst.uUART.ix2631.SI };
end

assign _sim_chain1_sobus[100] = cpu_inst.uPDR.ix700.QB;
assign _sim_chain1_sobus[99] = cpu_inst.uPDR.ix630.QB;
assign _sim_chain1_sobus[98] = cpu_inst.uPDR.ix640.QB;
assign _sim_chain1_sobus[97] = cpu_inst.uPDR.ix650.QB;
assign _sim_chain1_sobus[96] = cpu_inst.uPDR.ix660.QB;
assign _sim_chain1_sobus[95] = cpu_inst.uPDR.ix670.QB;
assign _sim_chain1_sobus[94] = cpu_inst.uPDR.ix680.QB;
assign _sim_chain1_sobus[93] = cpu_inst.uPDR.ix690.QB;
assign _sim_chain1_sobus[92] = cpu_inst.uCNTR.ix1003.Q;
assign _sim_chain1_sobus[91] = cpu_inst.uCNTR.ix1053.Q;
assign _sim_chain1_sobus[90] = cpu_inst.uCNTR.ix1103.Q;
assign _sim_chain1_sobus[89] = cpu_inst.uCNTR.ix1113.Q;
assign _sim_chain1_sobus[88] = cpu_inst.uCNTR.ix1163.Q;
assign _sim_chain1_sobus[87] = cpu_inst.uCNTR.ix1173.Q;
assign _sim_chain1_sobus[86] = cpu_inst.uCNTR.ix1063.Q;
assign _sim_chain1_sobus[85] = cpu_inst.uCNTR.ix1013.Q;
assign _sim_chain1_sobus[84] = cpu_inst.uCNTR.ix1183.QB;
assign _sim_chain1_sobus[83] = cpu_inst.uCNTR.ix1123.QB;
assign _sim_chain1_sobus[82] = cpu_inst.uCNTR.uTH0.ix134.QB;
assign _sim_chain1_sobus[81] = cpu_inst.uCNTR.uTH0.ix64.QB;
assign _sim_chain1_sobus[80] = cpu_inst.uCNTR.uTH0.ix74.QB;
assign _sim_chain1_sobus[79] = cpu_inst.uCNTR.uTH0.ix84.QB;
assign _sim_chain1_sobus[78] = cpu_inst.uCNTR.uTH0.ix94.QB;
assign _sim_chain1_sobus[77] = cpu_inst.uCNTR.uTH0.ix104.QB;
assign _sim_chain1_sobus[76] = cpu_inst.uCNTR.uTH0.ix114.Q;
assign _sim_chain1_sobus[75] = cpu_inst.uCNTR.uTH0.ix124.QB;
assign _sim_chain1_sobus[74] = cpu_inst.uCNTR.uTL1.ix447.QB;
assign _sim_chain1_sobus[73] = cpu_inst.uCNTR.uTL1.ix377.QB;
assign _sim_chain1_sobus[72] = cpu_inst.uCNTR.uTL1.ix387.QB;
assign _sim_chain1_sobus[71] = cpu_inst.uCNTR.uTL1.ix397.QB;
assign _sim_chain1_sobus[70] = cpu_inst.uCNTR.uTL1.ix407.QB;
assign _sim_chain1_sobus[69] = cpu_inst.uCNTR.uTL1.ix417.QB;
assign _sim_chain1_sobus[68] = cpu_inst.uCNTR.uTL1.ix427.QB;
assign _sim_chain1_sobus[67] = cpu_inst.uCNTR.uTL1.ix437.QB;
assign _sim_chain1_sobus[66] = cpu_inst.uCNTR.uTH1.ix134.QB;
assign _sim_chain1_sobus[65] = cpu_inst.uCNTR.uTH1.ix64.QB;
assign _sim_chain1_sobus[64] = cpu_inst.uCNTR.uTH1.ix74.QB;
assign _sim_chain1_sobus[63] = cpu_inst.uCNTR.uTH1.ix84.QB;
assign _sim_chain1_sobus[62] = cpu_inst.uCNTR.uTH1.ix94.QB;
assign _sim_chain1_sobus[61] = cpu_inst.uCNTR.uTH1.ix104.QB;
assign _sim_chain1_sobus[60] = cpu_inst.uCNTR.uTH1.ix114.Q;
assign _sim_chain1_sobus[59] = cpu_inst.uCNTR.uTH1.ix124.QB;
assign _sim_chain1_sobus[58] = cpu_inst.uCNTR.uTL0.ix447.QB;
assign _sim_chain1_sobus[57] = cpu_inst.uCNTR.uTL0.ix377.QB;
assign _sim_chain1_sobus[56] = cpu_inst.uCNTR.uTL0.ix387.QB;
assign _sim_chain1_sobus[55] = cpu_inst.uCNTR.uTL0.ix397.QB;
assign _sim_chain1_sobus[54] = cpu_inst.uCNTR.uTL0.ix407.QB;
assign _sim_chain1_sobus[53] = cpu_inst.uCNTR.uTL0.ix417.QB;
assign _sim_chain1_sobus[52] = cpu_inst.uCNTR.uTL0.ix427.QB;
assign _sim_chain1_sobus[51] = cpu_inst.uCNTR.uTL0.ix437.QB;
assign _sim_chain1_sobus[50] = cpu_inst.uUART.ix2531.QB;
assign _sim_chain1_sobus[49] = cpu_inst.uUART.ix2521.QB;
assign _sim_chain1_sobus[48] = cpu_inst.uUART.ix2511.QB;
assign _sim_chain1_sobus[47] = cpu_inst.uUART.ix2251.Q;
assign _sim_chain1_sobus[46] = cpu_inst.uUART.ix2241.Q;
assign _sim_chain1_sobus[45] = cpu_inst.uUART.ix2231.Q;
assign _sim_chain1_sobus[44] = cpu_inst.uUART.ix2221.Q;
assign _sim_chain1_sobus[43] = cpu_inst.uUART.ix2211.Q;
assign _sim_chain1_sobus[42] = cpu_inst.uUART.ix2201.Q;
assign _sim_chain1_sobus[41] = cpu_inst.uUART.ix2191.Q;
assign _sim_chain1_sobus[40] = cpu_inst.uUART.ix2181.Q;
assign _sim_chain1_sobus[39] = cpu_inst.uUART.ix2161.Q;
assign _sim_chain1_sobus[38] = cpu_inst.uUART.ix2151.QB;
assign _sim_chain1_sobus[37] = cpu_inst.uUART.ix2101.Q;
assign _sim_chain1_sobus[36] = cpu_inst.uUART.ix2111.Q;
assign _sim_chain1_sobus[35] = cpu_inst.uUART.ix2121.Q;
assign _sim_chain1_sobus[34] = cpu_inst.uUART.ix2141.Q;
assign _sim_chain1_sobus[33] = cpu_inst.uUART.ix2131.Q;
assign _sim_chain1_sobus[32] = cpu_inst.uUART.ix2261.Q;
assign _sim_chain1_sobus[31] = cpu_inst.uUART.ix2541.QB;
assign _sim_chain1_sobus[30] = cpu_inst.uUART.ix2351.Q;
assign _sim_chain1_sobus[29] = cpu_inst.uUART.ix2291.Q;
assign _sim_chain1_sobus[28] = cpu_inst.uUART.ix2281.Q;
assign _sim_chain1_sobus[27] = cpu_inst.uUART.ix2501.Q;
assign _sim_chain1_sobus[26] = cpu_inst.uUART.ix2481.QB;
assign _sim_chain1_sobus[25] = cpu_inst.uUART.ix2391.Q;
assign _sim_chain1_sobus[24] = cpu_inst.uUART.ix2371.Q;
assign _sim_chain1_sobus[23] = cpu_inst.uUART.ix2331.Q;
assign _sim_chain1_sobus[22] = cpu_inst.uUART.ix2311.QB;
assign _sim_chain1_sobus[21] = cpu_inst.uUART.ix2321.Q;
assign _sim_chain1_sobus[20] = cpu_inst.uUART.ix2341.Q;
assign _sim_chain1_sobus[19] = cpu_inst.uUART.ix2381.Q;
assign _sim_chain1_sobus[18] = cpu_inst.uUART.ix2361.Q;
assign _sim_chain1_sobus[17] = cpu_inst.uUART.ix2471.Q;
assign _sim_chain1_sobus[16] = cpu_inst.uUART.ix2461.Q;
assign _sim_chain1_sobus[15] = cpu_inst.uUART.ix2451.Q;
assign _sim_chain1_sobus[14] = cpu_inst.uUART.ix2441.Q;
assign _sim_chain1_sobus[13] = cpu_inst.uUART.ix2431.Q;
assign _sim_chain1_sobus[12] = cpu_inst.uUART.ix2421.Q;
assign _sim_chain1_sobus[11] = cpu_inst.uUART.ix2411.Q;
assign _sim_chain1_sobus[10] = cpu_inst.uUART.ix2401.Q;
assign _sim_chain1_sobus[9] = cpu_inst.uUART.ix2271.Q;
assign _sim_chain1_sobus[8] = cpu_inst.uUART.ix2551.Q;
assign _sim_chain1_sobus[7] = cpu_inst.uUART.ix2561.Q;
assign _sim_chain1_sobus[6] = cpu_inst.uUART.ix2581.Q;
assign _sim_chain1_sobus[5] = cpu_inst.uUART.ix2571.Q;
assign _sim_chain1_sobus[4] = cpu_inst.uUART.ix2591.Q;
assign _sim_chain1_sobus[3] = cpu_inst.uUART.ix2601.Q;
assign _sim_chain1_sobus[2] = cpu_inst.uUART.ix2611.Q;
assign _sim_chain1_sobus[1] = cpu_inst.uUART.ix2621.Q;
assign _sim_chain1_sobus[0] = cpu_inst.uUART.ix2631.Q;

reg[28:0]    _exp_chain2_sobus, _msk_chain2_sobus, _frc_chain2_sibus;
wire[28:0]   _sim_chain2_sobus;

event  force_frc_chain2_sibus;
always @(force_frc_chain2_sibus) begin
force  {cpu_inst.uSTM.ix96.SFFR.SI , cpu_inst.uSTM.ix36.SFFS.SI , cpu_inst.uSTM.reg_WAIT_SYNC.SFFR.SI , 
     cpu_inst.uSTM.ix3.SFFS.SI , cpu_inst.uSTM.ix46.SFFS.SI , cpu_inst.uSTM.ix56.SFFR.SI , 
     cpu_inst.uINTR.ix106.SI , cpu_inst.uINTR.ix506.SI , cpu_inst.uINTR.ix476.SI , 
     cpu_inst.uINTR.ix446.SI , cpu_inst.uINTR.ix416.SI , cpu_inst.uINTR.ix386.SI , 
     cpu_inst.uINTR.ix356.SI , cpu_inst.uINTR.ix326.SI , cpu_inst.uINTR.ix296.SI , 
     cpu_inst.uINTR.ix266.SI , cpu_inst.uINTR.ix236.SI , cpu_inst.uINTR.ix206.SI , 
     cpu_inst.uINTR.ix176.SI , cpu_inst.uINTR.ix146.SI , cpu_inst.uINTR.ix516.SI , 
     cpu_inst.uINTR.ix526.SI , cpu_inst.uINTR.ix536.SI , cpu_inst.uINTR.ix546.SI , 
     cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_2_.SI , cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_3_.SI , 
     cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_4_.SI , cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_5_.SI , 
     cpu_inst.uUART.reg_MODE0_CLK.SI  } = _frc_chain2_sibus[28:0];
end


event release_frc_chain2_sibus;
always @(release_frc_chain2_sibus) begin
release  {cpu_inst.uSTM.ix96.SFFR.SI , cpu_inst.uSTM.ix36.SFFS.SI , cpu_inst.uSTM.reg_WAIT_SYNC.SFFR.SI , 
     cpu_inst.uSTM.ix3.SFFS.SI , cpu_inst.uSTM.ix46.SFFS.SI , cpu_inst.uSTM.ix56.SFFR.SI , 
     cpu_inst.uINTR.ix106.SI , cpu_inst.uINTR.ix506.SI , cpu_inst.uINTR.ix476.SI , 
     cpu_inst.uINTR.ix446.SI , cpu_inst.uINTR.ix416.SI , cpu_inst.uINTR.ix386.SI , 
     cpu_inst.uINTR.ix356.SI , cpu_inst.uINTR.ix326.SI , cpu_inst.uINTR.ix296.SI , 
     cpu_inst.uINTR.ix266.SI , cpu_inst.uINTR.ix236.SI , cpu_inst.uINTR.ix206.SI , 
     cpu_inst.uINTR.ix176.SI , cpu_inst.uINTR.ix146.SI , cpu_inst.uINTR.ix516.SI , 
     cpu_inst.uINTR.ix526.SI , cpu_inst.uINTR.ix536.SI , cpu_inst.uINTR.ix546.SI , 
     cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_2_.SI , cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_3_.SI , 
     cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_4_.SI , cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_5_.SI , 
     cpu_inst.uUART.reg_MODE0_CLK.SI };
end

assign _sim_chain2_sobus[28] = cpu_inst.uSTM.ix96.SFFR.Q;
assign _sim_chain2_sobus[27] = cpu_inst.uSTM.ix36.SFFS.Q;
assign _sim_chain2_sobus[26] = cpu_inst.uSTM.reg_WAIT_SYNC.SFFR.Q;
assign _sim_chain2_sobus[25] = cpu_inst.uSTM.ix3.SFFS.Q;
assign _sim_chain2_sobus[24] = cpu_inst.uSTM.ix46.SFFS.Q;
assign _sim_chain2_sobus[23] = cpu_inst.uSTM.ix56.SFFR.Q;
assign _sim_chain2_sobus[22] = cpu_inst.uINTR.ix106.QB;
assign _sim_chain2_sobus[21] = cpu_inst.uINTR.ix506.QB;
assign _sim_chain2_sobus[20] = cpu_inst.uINTR.ix476.QB;
assign _sim_chain2_sobus[19] = cpu_inst.uINTR.ix446.QB;
assign _sim_chain2_sobus[18] = cpu_inst.uINTR.ix416.QB;
assign _sim_chain2_sobus[17] = cpu_inst.uINTR.ix386.QB;
assign _sim_chain2_sobus[16] = cpu_inst.uINTR.ix356.QB;
assign _sim_chain2_sobus[15] = cpu_inst.uINTR.ix326.QB;
assign _sim_chain2_sobus[14] = cpu_inst.uINTR.ix296.QB;
assign _sim_chain2_sobus[13] = cpu_inst.uINTR.ix266.QB;
assign _sim_chain2_sobus[12] = cpu_inst.uINTR.ix236.QB;
assign _sim_chain2_sobus[11] = cpu_inst.uINTR.ix206.QB;
assign _sim_chain2_sobus[10] = cpu_inst.uINTR.ix176.QB;
assign _sim_chain2_sobus[9] = cpu_inst.uINTR.ix146.QB;
assign _sim_chain2_sobus[8] = cpu_inst.uINTR.ix516.Q;
assign _sim_chain2_sobus[7] = cpu_inst.uINTR.ix526.Q;
assign _sim_chain2_sobus[6] = cpu_inst.uINTR.ix536.Q;
assign _sim_chain2_sobus[5] = cpu_inst.uINTR.ix546.QB;
assign _sim_chain2_sobus[4] = cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_2_.QB;
assign _sim_chain2_sobus[3] = cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_3_.QB;
assign _sim_chain2_sobus[2] = cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_4_.QB;
assign _sim_chain2_sobus[1] = cpu_inst.uCNTR.reg_PORT_3_SAMPLE_P1_5_.QB;
assign _sim_chain2_sobus[0] = cpu_inst.uUART.reg_MODE0_CLK.QB;

reg[151:0]    _exp_chain3_sobus, _msk_chain3_sobus, _frc_chain3_sibus;
wire[151:0]   _sim_chain3_sobus;

event  force_frc_chain3_sibus;
always @(force_frc_chain3_sibus) begin
force  {cpu_inst.uDMI.ix450.SI , cpu_inst.uDMI.ix500.SI , cpu_inst.uDMI.ix470.SI , 
     cpu_inst.uDMI.ix420.SI , cpu_inst.uDMI.ix330.SI , cpu_inst.uDMI.ix510.SI , 
     cpu_inst.uDMI.ix490.SI , cpu_inst.uDMI.ix520.SI , cpu_inst.uDMI.ix530.SI , 
     cpu_inst.uDMI.ix540.SI , cpu_inst.uDMI.ix550.SI , cpu_inst.uDMI.ix280.SI , 
     cpu_inst.uDMI.ix260.SI , cpu_inst.uDMI.ix240.SI , cpu_inst.uDMI.ix230.SI , 
     cpu_inst.uDMI.ix250.SI , cpu_inst.uDMI.ix270.SI , cpu_inst.uDMI.ix310.SI , 
     cpu_inst.uDMI.ix320.SI , cpu_inst.uDMI.ix340.SI , cpu_inst.uDMI.ix300.SI , 
     cpu_inst.uDMI.ix290.SI , cpu_inst.uDMI.ix360.SI , cpu_inst.uDMI.ix350.SI , 
     cpu_inst.uDMI.ix380.SI , cpu_inst.uDMI.ix370.SI , cpu_inst.uDMI.ix390.SI , 
     cpu_inst.uDMI.ix480.SI , cpu_inst.uDMI.ix410.SI , cpu_inst.uDMI.ix400.SI , 
     cpu_inst.uDMI.ix440.SI , cpu_inst.uDMI.ix430.SI , cpu_inst.uDMI.ix460.SI , 
     cpu_inst.uMUL.ix868.SI , cpu_inst.uMUL.ix788.SI , cpu_inst.uMUL.ix878.SI , 
     cpu_inst.uMUL.ix888.SI , cpu_inst.uMUL.ix858.SI , cpu_inst.uMUL.ix848.SI , 
     cpu_inst.uMUL.ix838.SI , cpu_inst.uMUL.ix828.SI , cpu_inst.uMUL.ix818.SI , 
     cpu_inst.uMUL.ix798.SI , cpu_inst.uMUL.ix808.SI , cpu_inst.uMUL.ix898.SI , 
     cpu_inst.uMUL.ix908.SI , cpu_inst.uMUL.ix918.SI , cpu_inst.uMUL.ix928.SI , 
     cpu_inst.uMUL.ix938.SI , cpu_inst.uCSFR.ix64.SI , cpu_inst.uCSFR.ix294.SI , 
     cpu_inst.uCSFR.ix144.SI , cpu_inst.uCSFR.ix154.SI , cpu_inst.uCSFR.ix164.SI , 
     cpu_inst.uCSFR.ix174.SI , cpu_inst.uCSFR.ix184.SI , cpu_inst.uCSFR.ix194.SI , 
     cpu_inst.uCSFR.ix204.SI , cpu_inst.uCSFR.ix214.SI , cpu_inst.uCSFR.ix224.SI , 
     cpu_inst.uCSFR.ix234.SI , cpu_inst.uCSFR.ix244.SI , cpu_inst.uCSFR.ix254.SI , 
     cpu_inst.uCSFR.ix264.SI , cpu_inst.uCSFR.ix274.SI , cpu_inst.uCSFR.ix284.SI , 
     cpu_inst.uCSFR.ix74.SI , cpu_inst.uCSFR.ix84.SI , cpu_inst.uCSFR.ix94.SI , 
     cpu_inst.uCSFR.ix104.SI , cpu_inst.uCSFR.ix114.SI , cpu_inst.uCSFR.ix124.SI , 
     cpu_inst.uCSFR.ix134.SI , cpu_inst.uPMI.ix876.SI , cpu_inst.uPMI.ix916.SI , 
     cpu_inst.uPMI.ix926.SI , cpu_inst.uPMI.ix936.SI , cpu_inst.uPMI.ix946.SI , 
     cpu_inst.uPMI.ix956.SI , cpu_inst.uPMI.ix966.SI , cpu_inst.uPMI.ix976.SI , 
     cpu_inst.uPMI.ix986.SI , cpu_inst.uPMI.ix996.SI , cpu_inst.uPMI.ix316.SI , 
     cpu_inst.uPMI.ix336.SI , cpu_inst.uPMI.ix356.SI , cpu_inst.uPMI.ix376.SI , 
     cpu_inst.uPMI.ix396.SI , cpu_inst.uPMI.ix416.SI , cpu_inst.uPMI.ix436.SI , 
     cpu_inst.uPMI.ix456.SI , cpu_inst.uPMI.ix906.SI , cpu_inst.uPMI.ix896.SI , 
     cpu_inst.uPMI.ix1006.SI , cpu_inst.uPMI.reg_LAST_RESET.SI , cpu_inst.uPMI.ix496.SI , 
     cpu_inst.uPMI.ix516.SI , cpu_inst.uPMI.ix536.SI , cpu_inst.uPMI.ix556.SI , 
     cpu_inst.uPMI.ix576.SI , cpu_inst.uPMI.ix596.SI , cpu_inst.uPMI.ix616.SI , 
     cpu_inst.uPMI.ix636.SI , cpu_inst.uPMI.ix306.SI , cpu_inst.uPMI.ix326.SI , 
     cpu_inst.uPMI.ix346.SI , cpu_inst.uPMI.ix366.SI , cpu_inst.uPMI.ix386.SI , 
     cpu_inst.uPMI.ix406.SI , cpu_inst.uPMI.ix426.SI , cpu_inst.uPMI.ix446.SI , 
     cpu_inst.uPMI.ix886.SI , cpu_inst.uPMI.ix476.SI , cpu_inst.uPMI.ix466.SI , 
     cpu_inst.uPMI.ix486.SI , cpu_inst.uPMI.ix506.SI , cpu_inst.uPMI.ix526.SI , 
     cpu_inst.uPMI.ix546.SI , cpu_inst.uPMI.ix566.SI , cpu_inst.uPMI.ix586.SI , 
     cpu_inst.uPMI.ix606.SI , cpu_inst.uPMI.ix626.SI , cpu_inst.uPMI.ix646.SI , 
     cpu_inst.uPMI.ix656.SI , cpu_inst.uPMI.ix666.SI , cpu_inst.uPMI.ix676.SI , 
     cpu_inst.uPMI.ix686.SI , cpu_inst.uPMI.ix696.SI , cpu_inst.uPMI.ix706.SI , 
     cpu_inst.uPMI.ix716.SI , cpu_inst.uPMI.ix726.SI , cpu_inst.uPMI.ix736.SI , 
     cpu_inst.uPMI.ix746.SI , cpu_inst.uPMI.ix756.SI , cpu_inst.uPMI.ix766.SI , 
     cpu_inst.uPMI.ix776.SI , cpu_inst.uPMI.ix786.SI , cpu_inst.uPMI.ix796.SI , 
     cpu_inst.uPMI.ix806.SI , cpu_inst.uPMI.ix816.SI , cpu_inst.uPMI.ix826.SI , 
     cpu_inst.uPMI.ix836.SI , cpu_inst.uPMI.ix846.SI , cpu_inst.uPMI.ix856.SI , 
     cpu_inst.uPMI.ix866.SI , cpu_inst.uSTM.ix126.SI , cpu_inst.uSTM.ix86.SI , 
     cpu_inst.uSTM.ix76.SI , cpu_inst.uSTM.ix66.SI , cpu_inst.uSTM.ix106.SI , 
     cpu_inst.uSTM.ix116.SI , cpu_inst.uPDR.ix540.SI  } = _frc_chain3_sibus[151:0];
end


event release_frc_chain3_sibus;
always @(release_frc_chain3_sibus) begin
release  {cpu_inst.uDMI.ix450.SI , cpu_inst.uDMI.ix500.SI , cpu_inst.uDMI.ix470.SI , 
     cpu_inst.uDMI.ix420.SI , cpu_inst.uDMI.ix330.SI , cpu_inst.uDMI.ix510.SI , 
     cpu_inst.uDMI.ix490.SI , cpu_inst.uDMI.ix520.SI , cpu_inst.uDMI.ix530.SI , 
     cpu_inst.uDMI.ix540.SI , cpu_inst.uDMI.ix550.SI , cpu_inst.uDMI.ix280.SI , 
     cpu_inst.uDMI.ix260.SI , cpu_inst.uDMI.ix240.SI , cpu_inst.uDMI.ix230.SI , 
     cpu_inst.uDMI.ix250.SI , cpu_inst.uDMI.ix270.SI , cpu_inst.uDMI.ix310.SI , 
     cpu_inst.uDMI.ix320.SI , cpu_inst.uDMI.ix340.SI , cpu_inst.uDMI.ix300.SI , 
     cpu_inst.uDMI.ix290.SI , cpu_inst.uDMI.ix360.SI , cpu_inst.uDMI.ix350.SI , 
     cpu_inst.uDMI.ix380.SI , cpu_inst.uDMI.ix370.SI , cpu_inst.uDMI.ix390.SI , 
     cpu_inst.uDMI.ix480.SI , cpu_inst.uDMI.ix410.SI , cpu_inst.uDMI.ix400.SI , 
     cpu_inst.uDMI.ix440.SI , cpu_inst.uDMI.ix430.SI , cpu_inst.uDMI.ix460.SI , 
     cpu_inst.uMUL.ix868.SI , cpu_inst.uMUL.ix788.SI , cpu_inst.uMUL.ix878.SI , 
     cpu_inst.uMUL.ix888.SI , cpu_inst.uMUL.ix858.SI , cpu_inst.uMUL.ix848.SI , 
     cpu_inst.uMUL.ix838.SI , cpu_inst.uMUL.ix828.SI , cpu_inst.uMUL.ix818.SI , 
     cpu_inst.uMUL.ix798.SI , cpu_inst.uMUL.ix808.SI , cpu_inst.uMUL.ix898.SI , 
     cpu_inst.uMUL.ix908.SI , cpu_inst.uMUL.ix918.SI , cpu_inst.uMUL.ix928.SI , 
     cpu_inst.uMUL.ix938.SI , cpu_inst.uCSFR.ix64.SI , cpu_inst.uCSFR.ix294.SI , 
     cpu_inst.uCSFR.ix144.SI , cpu_inst.uCSFR.ix154.SI , cpu_inst.uCSFR.ix164.SI , 
     cpu_inst.uCSFR.ix174.SI , cpu_inst.uCSFR.ix184.SI , cpu_inst.uCSFR.ix194.SI , 
     cpu_inst.uCSFR.ix204.SI , cpu_inst.uCSFR.ix214.SI , cpu_inst.uCSFR.ix224.SI , 
     cpu_inst.uCSFR.ix234.SI , cpu_inst.uCSFR.ix244.SI , cpu_inst.uCSFR.ix254.SI , 
     cpu_inst.uCSFR.ix264.SI , cpu_inst.uCSFR.ix274.SI , cpu_inst.uCSFR.ix284.SI , 
     cpu_inst.uCSFR.ix74.SI , cpu_inst.uCSFR.ix84.SI , cpu_inst.uCSFR.ix94.SI , 
     cpu_inst.uCSFR.ix104.SI , cpu_inst.uCSFR.ix114.SI , cpu_inst.uCSFR.ix124.SI , 
     cpu_inst.uCSFR.ix134.SI , cpu_inst.uPMI.ix876.SI , cpu_inst.uPMI.ix916.SI , 
     cpu_inst.uPMI.ix926.SI , cpu_inst.uPMI.ix936.SI , cpu_inst.uPMI.ix946.SI , 
     cpu_inst.uPMI.ix956.SI , cpu_inst.uPMI.ix966.SI , cpu_inst.uPMI.ix976.SI , 
     cpu_inst.uPMI.ix986.SI , cpu_inst.uPMI.ix996.SI , cpu_inst.uPMI.ix316.SI , 
     cpu_inst.uPMI.ix336.SI , cpu_inst.uPMI.ix356.SI , cpu_inst.uPMI.ix376.SI , 
     cpu_inst.uPMI.ix396.SI , cpu_inst.uPMI.ix416.SI , cpu_inst.uPMI.ix436.SI , 
     cpu_inst.uPMI.ix456.SI , cpu_inst.uPMI.ix906.SI , cpu_inst.uPMI.ix896.SI , 
     cpu_inst.uPMI.ix1006.SI , cpu_inst.uPMI.reg_LAST_RESET.SI , cpu_inst.uPMI.ix496.SI , 
     cpu_inst.uPMI.ix516.SI , cpu_inst.uPMI.ix536.SI , cpu_inst.uPMI.ix556.SI , 
     cpu_inst.uPMI.ix576.SI , cpu_inst.uPMI.ix596.SI , cpu_inst.uPMI.ix616.SI , 
     cpu_inst.uPMI.ix636.SI , cpu_inst.uPMI.ix306.SI , cpu_inst.uPMI.ix326.SI , 
     cpu_inst.uPMI.ix346.SI , cpu_inst.uPMI.ix366.SI , cpu_inst.uPMI.ix386.SI , 
     cpu_inst.uPMI.ix406.SI , cpu_inst.uPMI.ix426.SI , cpu_inst.uPMI.ix446.SI , 
     cpu_inst.uPMI.ix886.SI , cpu_inst.uPMI.ix476.SI , cpu_inst.uPMI.ix466.SI , 
     cpu_inst.uPMI.ix486.SI , cpu_inst.uPMI.ix506.SI , cpu_inst.uPMI.ix526.SI , 
     cpu_inst.uPMI.ix546.SI , cpu_inst.uPMI.ix566.SI , cpu_inst.uPMI.ix586.SI , 
     cpu_inst.uPMI.ix606.SI , cpu_inst.uPMI.ix626.SI , cpu_inst.uPMI.ix646.SI , 
     cpu_inst.uPMI.ix656.SI , cpu_inst.uPMI.ix666.SI , cpu_inst.uPMI.ix676.SI , 
     cpu_inst.uPMI.ix686.SI , cpu_inst.uPMI.ix696.SI , cpu_inst.uPMI.ix706.SI , 
     cpu_inst.uPMI.ix716.SI , cpu_inst.uPMI.ix726.SI , cpu_inst.uPMI.ix736.SI , 
     cpu_inst.uPMI.ix746.SI , cpu_inst.uPMI.ix756.SI , cpu_inst.uPMI.ix766.SI , 
     cpu_inst.uPMI.ix776.SI , cpu_inst.uPMI.ix786.SI , cpu_inst.uPMI.ix796.SI , 
     cpu_inst.uPMI.ix806.SI , cpu_inst.uPMI.ix816.SI , cpu_inst.uPMI.ix826.SI , 
     cpu_inst.uPMI.ix836.SI , cpu_inst.uPMI.ix846.SI , cpu_inst.uPMI.ix856.SI , 
     cpu_inst.uPMI.ix866.SI , cpu_inst.uSTM.ix126.SI , cpu_inst.uSTM.ix86.SI , 
     cpu_inst.uSTM.ix76.SI , cpu_inst.uSTM.ix66.SI , cpu_inst.uSTM.ix106.SI , 
     cpu_inst.uSTM.ix116.SI , cpu_inst.uPDR.ix540.SI };
end

assign _sim_chain3_sobus[151] = cpu_inst.uDMI.ix450.Q;
assign _sim_chain3_sobus[150] = cpu_inst.uDMI.ix500.Q;
assign _sim_chain3_sobus[149] = cpu_inst.uDMI.ix470.QB;
assign _sim_chain3_sobus[148] = cpu_inst.uDMI.ix420.Q;
assign _sim_chain3_sobus[147] = cpu_inst.uDMI.ix330.QB;
assign _sim_chain3_sobus[146] = cpu_inst.uDMI.ix510.Q;
assign _sim_chain3_sobus[145] = cpu_inst.uDMI.ix490.QB;
assign _sim_chain3_sobus[144] = cpu_inst.uDMI.ix520.QB;
assign _sim_chain3_sobus[143] = cpu_inst.uDMI.ix530.QB;
assign _sim_chain3_sobus[142] = cpu_inst.uDMI.ix540.QB;
assign _sim_chain3_sobus[141] = cpu_inst.uDMI.ix550.QB;
assign _sim_chain3_sobus[140] = cpu_inst.uDMI.ix280.QB;
assign _sim_chain3_sobus[139] = cpu_inst.uDMI.ix260.QB;
assign _sim_chain3_sobus[138] = cpu_inst.uDMI.ix240.QB;
assign _sim_chain3_sobus[137] = cpu_inst.uDMI.ix230.QB;
assign _sim_chain3_sobus[136] = cpu_inst.uDMI.ix250.QB;
assign _sim_chain3_sobus[135] = cpu_inst.uDMI.ix270.QB;
assign _sim_chain3_sobus[134] = cpu_inst.uDMI.ix310.QB;
assign _sim_chain3_sobus[133] = cpu_inst.uDMI.ix320.QB;
assign _sim_chain3_sobus[132] = cpu_inst.uDMI.ix340.Q;
assign _sim_chain3_sobus[131] = cpu_inst.uDMI.ix300.Q;
assign _sim_chain3_sobus[130] = cpu_inst.uDMI.ix290.Q;
assign _sim_chain3_sobus[129] = cpu_inst.uDMI.ix360.Q;
assign _sim_chain3_sobus[128] = cpu_inst.uDMI.ix350.Q;
assign _sim_chain3_sobus[127] = cpu_inst.uDMI.ix380.Q;
assign _sim_chain3_sobus[126] = cpu_inst.uDMI.ix370.Q;
assign _sim_chain3_sobus[125] = cpu_inst.uDMI.ix390.Q;
assign _sim_chain3_sobus[124] = cpu_inst.uDMI.ix480.Q;
assign _sim_chain3_sobus[123] = cpu_inst.uDMI.ix410.Q;
assign _sim_chain3_sobus[122] = cpu_inst.uDMI.ix400.Q;
assign _sim_chain3_sobus[121] = cpu_inst.uDMI.ix440.Q;
assign _sim_chain3_sobus[120] = cpu_inst.uDMI.ix430.Q;
assign _sim_chain3_sobus[119] = cpu_inst.uDMI.ix460.Q;
assign _sim_chain3_sobus[118] = cpu_inst.uMUL.ix868.QB;
assign _sim_chain3_sobus[117] = cpu_inst.uMUL.ix788.QB;
assign _sim_chain3_sobus[116] = cpu_inst.uMUL.ix878.QB;
assign _sim_chain3_sobus[115] = cpu_inst.uMUL.ix888.QB;
assign _sim_chain3_sobus[114] = cpu_inst.uMUL.ix858.QB;
assign _sim_chain3_sobus[113] = cpu_inst.uMUL.ix848.QB;
assign _sim_chain3_sobus[112] = cpu_inst.uMUL.ix838.QB;
assign _sim_chain3_sobus[111] = cpu_inst.uMUL.ix828.QB;
assign _sim_chain3_sobus[110] = cpu_inst.uMUL.ix818.QB;
assign _sim_chain3_sobus[109] = cpu_inst.uMUL.ix798.QB;
assign _sim_chain3_sobus[108] = cpu_inst.uMUL.ix808.QB;
assign _sim_chain3_sobus[107] = cpu_inst.uMUL.ix898.QB;
assign _sim_chain3_sobus[106] = cpu_inst.uMUL.ix908.QB;
assign _sim_chain3_sobus[105] = cpu_inst.uMUL.ix918.QB;
assign _sim_chain3_sobus[104] = cpu_inst.uMUL.ix928.QB;
assign _sim_chain3_sobus[103] = cpu_inst.uMUL.ix938.QB;
assign _sim_chain3_sobus[102] = cpu_inst.uCSFR.ix64.Q;
assign _sim_chain3_sobus[101] = cpu_inst.uCSFR.ix294.QB;
assign _sim_chain3_sobus[100] = cpu_inst.uCSFR.ix144.QB;
assign _sim_chain3_sobus[99] = cpu_inst.uCSFR.ix154.QB;
assign _sim_chain3_sobus[98] = cpu_inst.uCSFR.ix164.Q;
assign _sim_chain3_sobus[97] = cpu_inst.uCSFR.ix174.QB;
assign _sim_chain3_sobus[96] = cpu_inst.uCSFR.ix184.QB;
assign _sim_chain3_sobus[95] = cpu_inst.uCSFR.ix194.QB;
assign _sim_chain3_sobus[94] = cpu_inst.uCSFR.ix204.Q;
assign _sim_chain3_sobus[93] = cpu_inst.uCSFR.ix214.Q;
assign _sim_chain3_sobus[92] = cpu_inst.uCSFR.ix224.QB;
assign _sim_chain3_sobus[91] = cpu_inst.uCSFR.ix234.QB;
assign _sim_chain3_sobus[90] = cpu_inst.uCSFR.ix244.QB;
assign _sim_chain3_sobus[89] = cpu_inst.uCSFR.ix254.QB;
assign _sim_chain3_sobus[88] = cpu_inst.uCSFR.ix264.QB;
assign _sim_chain3_sobus[87] = cpu_inst.uCSFR.ix274.QB;
assign _sim_chain3_sobus[86] = cpu_inst.uCSFR.ix284.QB;
assign _sim_chain3_sobus[85] = cpu_inst.uCSFR.ix74.Q;
assign _sim_chain3_sobus[84] = cpu_inst.uCSFR.ix84.Q;
assign _sim_chain3_sobus[83] = cpu_inst.uCSFR.ix94.Q;
assign _sim_chain3_sobus[82] = cpu_inst.uCSFR.ix104.Q;
assign _sim_chain3_sobus[81] = cpu_inst.uCSFR.ix114.Q;
assign _sim_chain3_sobus[80] = cpu_inst.uCSFR.ix124.Q;
assign _sim_chain3_sobus[79] = cpu_inst.uCSFR.ix134.Q;
assign _sim_chain3_sobus[78] = cpu_inst.uPMI.ix876.Q;
assign _sim_chain3_sobus[77] = cpu_inst.uPMI.ix916.Q;
assign _sim_chain3_sobus[76] = cpu_inst.uPMI.ix926.Q;
assign _sim_chain3_sobus[75] = cpu_inst.uPMI.ix936.Q;
assign _sim_chain3_sobus[74] = cpu_inst.uPMI.ix946.Q;
assign _sim_chain3_sobus[73] = cpu_inst.uPMI.ix956.Q;
assign _sim_chain3_sobus[72] = cpu_inst.uPMI.ix966.Q;
assign _sim_chain3_sobus[71] = cpu_inst.uPMI.ix976.Q;
assign _sim_chain3_sobus[70] = cpu_inst.uPMI.ix986.Q;
assign _sim_chain3_sobus[69] = cpu_inst.uPMI.ix996.Q;
assign _sim_chain3_sobus[68] = cpu_inst.uPMI.ix316.Q;
assign _sim_chain3_sobus[67] = cpu_inst.uPMI.ix336.Q;
assign _sim_chain3_sobus[66] = cpu_inst.uPMI.ix356.Q;
assign _sim_chain3_sobus[65] = cpu_inst.uPMI.ix376.Q;
assign _sim_chain3_sobus[64] = cpu_inst.uPMI.ix396.Q;
assign _sim_chain3_sobus[63] = cpu_inst.uPMI.ix416.Q;
assign _sim_chain3_sobus[62] = cpu_inst.uPMI.ix436.Q;
assign _sim_chain3_sobus[61] = cpu_inst.uPMI.ix456.Q;
assign _sim_chain3_sobus[60] = cpu_inst.uPMI.ix906.QB;
assign _sim_chain3_sobus[59] = cpu_inst.uPMI.ix896.QB;
assign _sim_chain3_sobus[58] = cpu_inst.uPMI.ix1006.QB;
assign _sim_chain3_sobus[57] = cpu_inst.uPMI.reg_LAST_RESET.Q;
assign _sim_chain3_sobus[56] = cpu_inst.uPMI.ix496.QB;
assign _sim_chain3_sobus[55] = cpu_inst.uPMI.ix516.QB;
assign _sim_chain3_sobus[54] = cpu_inst.uPMI.ix536.QB;
assign _sim_chain3_sobus[53] = cpu_inst.uPMI.ix556.QB;
assign _sim_chain3_sobus[52] = cpu_inst.uPMI.ix576.QB;
assign _sim_chain3_sobus[51] = cpu_inst.uPMI.ix596.QB;
assign _sim_chain3_sobus[50] = cpu_inst.uPMI.ix616.QB;
assign _sim_chain3_sobus[49] = cpu_inst.uPMI.ix636.QB;
assign _sim_chain3_sobus[48] = cpu_inst.uPMI.ix306.QB;
assign _sim_chain3_sobus[47] = cpu_inst.uPMI.ix326.QB;
assign _sim_chain3_sobus[46] = cpu_inst.uPMI.ix346.QB;
assign _sim_chain3_sobus[45] = cpu_inst.uPMI.ix366.QB;
assign _sim_chain3_sobus[44] = cpu_inst.uPMI.ix386.QB;
assign _sim_chain3_sobus[43] = cpu_inst.uPMI.ix406.QB;
assign _sim_chain3_sobus[42] = cpu_inst.uPMI.ix426.QB;
assign _sim_chain3_sobus[41] = cpu_inst.uPMI.ix446.QB;
assign _sim_chain3_sobus[40] = cpu_inst.uPMI.ix886.Q;
assign _sim_chain3_sobus[39] = cpu_inst.uPMI.ix476.Q;
assign _sim_chain3_sobus[38] = cpu_inst.uPMI.ix466.Q;
assign _sim_chain3_sobus[37] = cpu_inst.uPMI.ix486.Q;
assign _sim_chain3_sobus[36] = cpu_inst.uPMI.ix506.Q;
assign _sim_chain3_sobus[35] = cpu_inst.uPMI.ix526.Q;
assign _sim_chain3_sobus[34] = cpu_inst.uPMI.ix546.Q;
assign _sim_chain3_sobus[33] = cpu_inst.uPMI.ix566.Q;
assign _sim_chain3_sobus[32] = cpu_inst.uPMI.ix586.Q;
assign _sim_chain3_sobus[31] = cpu_inst.uPMI.ix606.Q;
assign _sim_chain3_sobus[30] = cpu_inst.uPMI.ix626.Q;
assign _sim_chain3_sobus[29] = cpu_inst.uPMI.ix646.Q;
assign _sim_chain3_sobus[28] = cpu_inst.uPMI.ix656.Q;
assign _sim_chain3_sobus[27] = cpu_inst.uPMI.ix666.Q;
assign _sim_chain3_sobus[26] = cpu_inst.uPMI.ix676.Q;
assign _sim_chain3_sobus[25] = cpu_inst.uPMI.ix686.Q;
assign _sim_chain3_sobus[24] = cpu_inst.uPMI.ix696.Q;
assign _sim_chain3_sobus[23] = cpu_inst.uPMI.ix706.Q;
assign _sim_chain3_sobus[22] = cpu_inst.uPMI.ix716.Q;
assign _sim_chain3_sobus[21] = cpu_inst.uPMI.ix726.Q;
assign _sim_chain3_sobus[20] = cpu_inst.uPMI.ix736.Q;
assign _sim_chain3_sobus[19] = cpu_inst.uPMI.ix746.Q;
assign _sim_chain3_sobus[18] = cpu_inst.uPMI.ix756.Q;
assign _sim_chain3_sobus[17] = cpu_inst.uPMI.ix766.Q;
assign _sim_chain3_sobus[16] = cpu_inst.uPMI.ix776.Q;
assign _sim_chain3_sobus[15] = cpu_inst.uPMI.ix786.Q;
assign _sim_chain3_sobus[14] = cpu_inst.uPMI.ix796.Q;
assign _sim_chain3_sobus[13] = cpu_inst.uPMI.ix806.Q;
assign _sim_chain3_sobus[12] = cpu_inst.uPMI.ix816.Q;
assign _sim_chain3_sobus[11] = cpu_inst.uPMI.ix826.Q;
assign _sim_chain3_sobus[10] = cpu_inst.uPMI.ix836.Q;
assign _sim_chain3_sobus[9] = cpu_inst.uPMI.ix846.Q;
assign _sim_chain3_sobus[8] = cpu_inst.uPMI.ix856.Q;
assign _sim_chain3_sobus[7] = cpu_inst.uPMI.ix866.Q;
assign _sim_chain3_sobus[6] = cpu_inst.uSTM.ix126.QB;
assign _sim_chain3_sobus[5] = cpu_inst.uSTM.ix86.QB;
assign _sim_chain3_sobus[4] = cpu_inst.uSTM.ix76.QB;
assign _sim_chain3_sobus[3] = cpu_inst.uSTM.ix66.QB;
assign _sim_chain3_sobus[2] = cpu_inst.uSTM.ix106.QB;
assign _sim_chain3_sobus[1] = cpu_inst.uSTM.ix116.QB;
assign _sim_chain3_sobus[0] = cpu_inst.uPDR.ix540.QB;

reg[151:0]    _exp_chain4_sobus, _msk_chain4_sobus, _frc_chain4_sibus;
wire[151:0]   _sim_chain4_sobus;

event  force_frc_chain4_sibus;
always @(force_frc_chain4_sibus) begin
force  {cpu_inst.uPORT.ix995.SI , cpu_inst.uPORT.ix1704.SI , cpu_inst.uPORT.ix1724.SI , 
     cpu_inst.uPORT.ix1744.SI , cpu_inst.uPORT.ix1764.SI , cpu_inst.uPORT.ix1784.SI , 
     cpu_inst.uPORT.ix1804.SI , cpu_inst.uPORT.ix1824.SI , cpu_inst.uPORT.ix1844.SI , 
     cpu_inst.uPORT.ix1544.SI , cpu_inst.uPORT.ix1564.SI , cpu_inst.uPORT.ix1584.SI , 
     cpu_inst.uPORT.ix1604.SI , cpu_inst.uPORT.ix1624.SI , cpu_inst.uPORT.ix1644.SI , 
     cpu_inst.uPORT.ix1664.SI , cpu_inst.uPORT.ix1684.SI , cpu_inst.uPORT.ix1384.SI , 
     cpu_inst.uPORT.ix1404.SI , cpu_inst.uPORT.ix1424.SI , cpu_inst.uPORT.ix1444.SI , 
     cpu_inst.uPORT.ix1464.SI , cpu_inst.uPORT.ix1484.SI , cpu_inst.uPORT.ix1504.SI , 
     cpu_inst.uPORT.ix1524.SI , cpu_inst.uPORT.ix1224.SI , cpu_inst.uPORT.ix1244.SI , 
     cpu_inst.uPORT.ix1264.SI , cpu_inst.uPORT.ix1284.SI , cpu_inst.uPORT.ix1304.SI , 
     cpu_inst.uPORT.ix1324.SI , cpu_inst.uPORT.ix1344.SI , cpu_inst.uPORT.ix1364.SI , 
     cpu_inst.uPORT.ix1714.SI , cpu_inst.uPORT.ix1734.SI , cpu_inst.uPORT.ix673.SI , 
     cpu_inst.uPORT.ix687.SI , cpu_inst.uPORT.ix1754.SI , cpu_inst.uPORT.ix1774.SI , 
     cpu_inst.uPORT.ix1794.SI , cpu_inst.uPORT.ix1814.SI , cpu_inst.uPORT.ix1834.SI , 
     cpu_inst.uPORT.ix1854.SI , cpu_inst.uPORT.ix1554.SI , cpu_inst.uPORT.ix1574.SI , 
     cpu_inst.uPORT.ix1594.SI , cpu_inst.uPORT.ix1614.SI , cpu_inst.uPORT.ix1634.SI , 
     cpu_inst.uPORT.ix1654.SI , cpu_inst.uPORT.ix1674.SI , cpu_inst.uPORT.ix1694.SI , 
     cpu_inst.uPORT.ix1394.SI , cpu_inst.uPORT.ix1414.SI , cpu_inst.uPORT.ix1434.SI , 
     cpu_inst.uPORT.ix1454.SI , cpu_inst.uPORT.ix1474.SI , cpu_inst.uPORT.ix1494.SI , 
     cpu_inst.uPORT.ix1514.SI , cpu_inst.uPORT.ix1534.SI , cpu_inst.uPORT.ix1234.SI , 
     cpu_inst.uPORT.ix1254.SI , cpu_inst.uPORT.ix1274.SI , cpu_inst.uPORT.ix1294.SI , 
     cpu_inst.uPORT.ix1314.SI , cpu_inst.uPORT.ix1334.SI , cpu_inst.uPORT.ix1354.SI , 
     cpu_inst.uPORT.ix1374.SI , cpu_inst.uPORT.ix701.SI , cpu_inst.uPORT.ix715.SI , 
     cpu_inst.uPORT.ix729.SI , cpu_inst.uPORT.ix743.SI , cpu_inst.uPORT.ix757.SI , 
     cpu_inst.uPORT.ix771.SI , cpu_inst.uPORT.ix785.SI , cpu_inst.uPORT.ix799.SI , 
     cpu_inst.uPORT.ix813.SI , cpu_inst.uPORT.ix827.SI , cpu_inst.uPORT.ix841.SI , 
     cpu_inst.uPORT.ix855.SI , cpu_inst.uPORT.ix869.SI , cpu_inst.uPORT.ix883.SI , 
     cpu_inst.uPORT.ix897.SI , cpu_inst.uPORT.ix911.SI , cpu_inst.uPORT.ix925.SI , 
     cpu_inst.uPORT.ix939.SI , cpu_inst.uPORT.ix953.SI , cpu_inst.uPORT.ix967.SI , 
     cpu_inst.uPORT.ix981.SI , cpu_inst.uINTR.ix576.SI , cpu_inst.uINTR.ix86.SI , 
     cpu_inst.uINTR.ix96.SI , cpu_inst.uINTR.ix116.SI , cpu_inst.uINTR.ix486.SI , 
     cpu_inst.uINTR.ix496.SI , cpu_inst.uINTR.ix456.SI , cpu_inst.uINTR.ix466.SI , 
     cpu_inst.uINTR.ix426.SI , cpu_inst.uINTR.ix436.SI , cpu_inst.uINTR.ix396.SI , 
     cpu_inst.uINTR.ix406.SI , cpu_inst.uINTR.ix366.SI , cpu_inst.uINTR.ix376.SI , 
     cpu_inst.uINTR.ix336.SI , cpu_inst.uINTR.ix346.SI , cpu_inst.uINTR.ix306.SI , 
     cpu_inst.uINTR.ix316.SI , cpu_inst.uINTR.ix276.SI , cpu_inst.uINTR.ix286.SI , 
     cpu_inst.uINTR.ix246.SI , cpu_inst.uINTR.ix256.SI , cpu_inst.uINTR.ix216.SI , 
     cpu_inst.uINTR.ix226.SI , cpu_inst.uINTR.ix186.SI , cpu_inst.uINTR.ix196.SI , 
     cpu_inst.uINTR.ix156.SI , cpu_inst.uINTR.ix166.SI , cpu_inst.uINTR.ix126.SI , 
     cpu_inst.uINTR.ix136.SI , cpu_inst.uINTR.ix556.SI , cpu_inst.uINTR.ix566.SI , 
     cpu_inst.uCNTR.ix1043.SI , cpu_inst.uCNTR.ix1083.SI , cpu_inst.uCNTR.ix1153.SI , 
     cpu_inst.uCNTR.ix1143.SI , cpu_inst.uCNTR.ix973.SI , cpu_inst.uCNTR.ix993.SI , 
     cpu_inst.uCNTR.ix1093.SI , cpu_inst.uCNTR.ix1073.SI , cpu_inst.uCNTR.ix1023.SI , 
     cpu_inst.uCNTR.ix1133.SI , cpu_inst.uCNTR.ix1033.SI , cpu_inst.uCNTR.ix983.SI , 
     cpu_inst.uUART.ix2091.SI , cpu_inst.uUART.ix2081.SI , cpu_inst.uUART.ix2171.SI , 
     cpu_inst.uUART.ix2301.SI , cpu_inst.uUART.ix2491.SI , cpu_inst.uPDR.ix550.SI , 
     cpu_inst.uPDR.ix560.SI , cpu_inst.uPDR.ix570.SI , cpu_inst.uPDR.ix580.SI , 
     cpu_inst.uPDR.ix590.SI , cpu_inst.uPDR.ix600.SI , cpu_inst.uPDR.ix610.SI , 
     cpu_inst.uPDR.ix620.SI , cpu_inst.uPDR.ix470.SI , cpu_inst.uPDR.ix480.SI , 
     cpu_inst.uPDR.ix490.SI , cpu_inst.uPDR.ix500.SI , cpu_inst.uPDR.ix510.SI , 
     cpu_inst.uPDR.ix520.SI , cpu_inst.uPDR.ix530.SI  } = _frc_chain4_sibus[151:0];
end


event release_frc_chain4_sibus;
always @(release_frc_chain4_sibus) begin
release  {cpu_inst.uPORT.ix995.SI , cpu_inst.uPORT.ix1704.SI , cpu_inst.uPORT.ix1724.SI , 
     cpu_inst.uPORT.ix1744.SI , cpu_inst.uPORT.ix1764.SI , cpu_inst.uPORT.ix1784.SI , 
     cpu_inst.uPORT.ix1804.SI , cpu_inst.uPORT.ix1824.SI , cpu_inst.uPORT.ix1844.SI , 
     cpu_inst.uPORT.ix1544.SI , cpu_inst.uPORT.ix1564.SI , cpu_inst.uPORT.ix1584.SI , 
     cpu_inst.uPORT.ix1604.SI , cpu_inst.uPORT.ix1624.SI , cpu_inst.uPORT.ix1644.SI , 
     cpu_inst.uPORT.ix1664.SI , cpu_inst.uPORT.ix1684.SI , cpu_inst.uPORT.ix1384.SI , 
     cpu_inst.uPORT.ix1404.SI , cpu_inst.uPORT.ix1424.SI , cpu_inst.uPORT.ix1444.SI , 
     cpu_inst.uPORT.ix1464.SI , cpu_inst.uPORT.ix1484.SI , cpu_inst.uPORT.ix1504.SI , 
     cpu_inst.uPORT.ix1524.SI , cpu_inst.uPORT.ix1224.SI , cpu_inst.uPORT.ix1244.SI , 
     cpu_inst.uPORT.ix1264.SI , cpu_inst.uPORT.ix1284.SI , cpu_inst.uPORT.ix1304.SI , 
     cpu_inst.uPORT.ix1324.SI , cpu_inst.uPORT.ix1344.SI , cpu_inst.uPORT.ix1364.SI , 
     cpu_inst.uPORT.ix1714.SI , cpu_inst.uPORT.ix1734.SI , cpu_inst.uPORT.ix673.SI , 
     cpu_inst.uPORT.ix687.SI , cpu_inst.uPORT.ix1754.SI , cpu_inst.uPORT.ix1774.SI , 
     cpu_inst.uPORT.ix1794.SI , cpu_inst.uPORT.ix1814.SI , cpu_inst.uPORT.ix1834.SI , 
     cpu_inst.uPORT.ix1854.SI , cpu_inst.uPORT.ix1554.SI , cpu_inst.uPORT.ix1574.SI , 
     cpu_inst.uPORT.ix1594.SI , cpu_inst.uPORT.ix1614.SI , cpu_inst.uPORT.ix1634.SI , 
     cpu_inst.uPORT.ix1654.SI , cpu_inst.uPORT.ix1674.SI , cpu_inst.uPORT.ix1694.SI , 
     cpu_inst.uPORT.ix1394.SI , cpu_inst.uPORT.ix1414.SI , cpu_inst.uPORT.ix1434.SI , 
     cpu_inst.uPORT.ix1454.SI , cpu_inst.uPORT.ix1474.SI , cpu_inst.uPORT.ix1494.SI , 
     cpu_inst.uPORT.ix1514.SI , cpu_inst.uPORT.ix1534.SI , cpu_inst.uPORT.ix1234.SI , 
     cpu_inst.uPORT.ix1254.SI , cpu_inst.uPORT.ix1274.SI , cpu_inst.uPORT.ix1294.SI , 
     cpu_inst.uPORT.ix1314.SI , cpu_inst.uPORT.ix1334.SI , cpu_inst.uPORT.ix1354.SI , 
     cpu_inst.uPORT.ix1374.SI , cpu_inst.uPORT.ix701.SI , cpu_inst.uPORT.ix715.SI , 
     cpu_inst.uPORT.ix729.SI , cpu_inst.uPORT.ix743.SI , cpu_inst.uPORT.ix757.SI , 
     cpu_inst.uPORT.ix771.SI , cpu_inst.uPORT.ix785.SI , cpu_inst.uPORT.ix799.SI , 
     cpu_inst.uPORT.ix813.SI , cpu_inst.uPORT.ix827.SI , cpu_inst.uPORT.ix841.SI , 
     cpu_inst.uPORT.ix855.SI , cpu_inst.uPORT.ix869.SI , cpu_inst.uPORT.ix883.SI , 
     cpu_inst.uPORT.ix897.SI , cpu_inst.uPORT.ix911.SI , cpu_inst.uPORT.ix925.SI , 
     cpu_inst.uPORT.ix939.SI , cpu_inst.uPORT.ix953.SI , cpu_inst.uPORT.ix967.SI , 
     cpu_inst.uPORT.ix981.SI , cpu_inst.uINTR.ix576.SI , cpu_inst.uINTR.ix86.SI , 
     cpu_inst.uINTR.ix96.SI , cpu_inst.uINTR.ix116.SI , cpu_inst.uINTR.ix486.SI , 
     cpu_inst.uINTR.ix496.SI , cpu_inst.uINTR.ix456.SI , cpu_inst.uINTR.ix466.SI , 
     cpu_inst.uINTR.ix426.SI , cpu_inst.uINTR.ix436.SI , cpu_inst.uINTR.ix396.SI , 
     cpu_inst.uINTR.ix406.SI , cpu_inst.uINTR.ix366.SI , cpu_inst.uINTR.ix376.SI , 
     cpu_inst.uINTR.ix336.SI , cpu_inst.uINTR.ix346.SI , cpu_inst.uINTR.ix306.SI , 
     cpu_inst.uINTR.ix316.SI , cpu_inst.uINTR.ix276.SI , cpu_inst.uINTR.ix286.SI , 
     cpu_inst.uINTR.ix246.SI , cpu_inst.uINTR.ix256.SI , cpu_inst.uINTR.ix216.SI , 
     cpu_inst.uINTR.ix226.SI , cpu_inst.uINTR.ix186.SI , cpu_inst.uINTR.ix196.SI , 
     cpu_inst.uINTR.ix156.SI , cpu_inst.uINTR.ix166.SI , cpu_inst.uINTR.ix126.SI , 
     cpu_inst.uINTR.ix136.SI , cpu_inst.uINTR.ix556.SI , cpu_inst.uINTR.ix566.SI , 
     cpu_inst.uCNTR.ix1043.SI , cpu_inst.uCNTR.ix1083.SI , cpu_inst.uCNTR.ix1153.SI , 
     cpu_inst.uCNTR.ix1143.SI , cpu_inst.uCNTR.ix973.SI , cpu_inst.uCNTR.ix993.SI , 
     cpu_inst.uCNTR.ix1093.SI , cpu_inst.uCNTR.ix1073.SI , cpu_inst.uCNTR.ix1023.SI , 
     cpu_inst.uCNTR.ix1133.SI , cpu_inst.uCNTR.ix1033.SI , cpu_inst.uCNTR.ix983.SI , 
     cpu_inst.uUART.ix2091.SI , cpu_inst.uUART.ix2081.SI , cpu_inst.uUART.ix2171.SI , 
     cpu_inst.uUART.ix2301.SI , cpu_inst.uUART.ix2491.SI , cpu_inst.uPDR.ix550.SI , 
     cpu_inst.uPDR.ix560.SI , cpu_inst.uPDR.ix570.SI , cpu_inst.uPDR.ix580.SI , 
     cpu_inst.uPDR.ix590.SI , cpu_inst.uPDR.ix600.SI , cpu_inst.uPDR.ix610.SI , 
     cpu_inst.uPDR.ix620.SI , cpu_inst.uPDR.ix470.SI , cpu_inst.uPDR.ix480.SI , 
     cpu_inst.uPDR.ix490.SI , cpu_inst.uPDR.ix500.SI , cpu_inst.uPDR.ix510.SI , 
     cpu_inst.uPDR.ix520.SI , cpu_inst.uPDR.ix530.SI };
end

assign _sim_chain4_sobus[151] = cpu_inst.uPORT.ix995.Q;
assign _sim_chain4_sobus[150] = cpu_inst.uPORT.ix1704.Q;
assign _sim_chain4_sobus[149] = cpu_inst.uPORT.ix1724.Q;
assign _sim_chain4_sobus[148] = cpu_inst.uPORT.ix1744.Q;
assign _sim_chain4_sobus[147] = cpu_inst.uPORT.ix1764.Q;
assign _sim_chain4_sobus[146] = cpu_inst.uPORT.ix1784.Q;
assign _sim_chain4_sobus[145] = cpu_inst.uPORT.ix1804.Q;
assign _sim_chain4_sobus[144] = cpu_inst.uPORT.ix1824.Q;
assign _sim_chain4_sobus[143] = cpu_inst.uPORT.ix1844.Q;
assign _sim_chain4_sobus[142] = cpu_inst.uPORT.ix1544.Q;
assign _sim_chain4_sobus[141] = cpu_inst.uPORT.ix1564.Q;
assign _sim_chain4_sobus[140] = cpu_inst.uPORT.ix1584.Q;
assign _sim_chain4_sobus[139] = cpu_inst.uPORT.ix1604.Q;
assign _sim_chain4_sobus[138] = cpu_inst.uPORT.ix1624.Q;
assign _sim_chain4_sobus[137] = cpu_inst.uPORT.ix1644.Q;
assign _sim_chain4_sobus[136] = cpu_inst.uPORT.ix1664.Q;
assign _sim_chain4_sobus[135] = cpu_inst.uPORT.ix1684.Q;
assign _sim_chain4_sobus[134] = cpu_inst.uPORT.ix1384.Q;
assign _sim_chain4_sobus[133] = cpu_inst.uPORT.ix1404.Q;
assign _sim_chain4_sobus[132] = cpu_inst.uPORT.ix1424.Q;
assign _sim_chain4_sobus[131] = cpu_inst.uPORT.ix1444.Q;
assign _sim_chain4_sobus[130] = cpu_inst.uPORT.ix1464.Q;
assign _sim_chain4_sobus[129] = cpu_inst.uPORT.ix1484.Q;
assign _sim_chain4_sobus[128] = cpu_inst.uPORT.ix1504.Q;
assign _sim_chain4_sobus[127] = cpu_inst.uPORT.ix1524.Q;
assign _sim_chain4_sobus[126] = cpu_inst.uPORT.ix1224.Q;
assign _sim_chain4_sobus[125] = cpu_inst.uPORT.ix1244.Q;
assign _sim_chain4_sobus[124] = cpu_inst.uPORT.ix1264.Q;
assign _sim_chain4_sobus[123] = cpu_inst.uPORT.ix1284.Q;
assign _sim_chain4_sobus[122] = cpu_inst.uPORT.ix1304.Q;
assign _sim_chain4_sobus[121] = cpu_inst.uPORT.ix1324.Q;
assign _sim_chain4_sobus[120] = cpu_inst.uPORT.ix1344.Q;
assign _sim_chain4_sobus[119] = cpu_inst.uPORT.ix1364.Q;
assign _sim_chain4_sobus[118] = cpu_inst.uPORT.ix1714.QB;
assign _sim_chain4_sobus[117] = cpu_inst.uPORT.ix1734.QB;
assign _sim_chain4_sobus[116] = cpu_inst.uPORT.ix673.QB;
assign _sim_chain4_sobus[115] = cpu_inst.uPORT.ix687.QB;
assign _sim_chain4_sobus[114] = cpu_inst.uPORT.ix1754.Q;
assign _sim_chain4_sobus[113] = cpu_inst.uPORT.ix1774.Q;
assign _sim_chain4_sobus[112] = cpu_inst.uPORT.ix1794.Q;
assign _sim_chain4_sobus[111] = cpu_inst.uPORT.ix1814.Q;
assign _sim_chain4_sobus[110] = cpu_inst.uPORT.ix1834.Q;
assign _sim_chain4_sobus[109] = cpu_inst.uPORT.ix1854.Q;
assign _sim_chain4_sobus[108] = cpu_inst.uPORT.ix1554.Q;
assign _sim_chain4_sobus[107] = cpu_inst.uPORT.ix1574.Q;
assign _sim_chain4_sobus[106] = cpu_inst.uPORT.ix1594.Q;
assign _sim_chain4_sobus[105] = cpu_inst.uPORT.ix1614.Q;
assign _sim_chain4_sobus[104] = cpu_inst.uPORT.ix1634.Q;
assign _sim_chain4_sobus[103] = cpu_inst.uPORT.ix1654.Q;
assign _sim_chain4_sobus[102] = cpu_inst.uPORT.ix1674.Q;
assign _sim_chain4_sobus[101] = cpu_inst.uPORT.ix1694.Q;
assign _sim_chain4_sobus[100] = cpu_inst.uPORT.ix1394.Q;
assign _sim_chain4_sobus[99] = cpu_inst.uPORT.ix1414.Q;
assign _sim_chain4_sobus[98] = cpu_inst.uPORT.ix1434.Q;
assign _sim_chain4_sobus[97] = cpu_inst.uPORT.ix1454.Q;
assign _sim_chain4_sobus[96] = cpu_inst.uPORT.ix1474.Q;
assign _sim_chain4_sobus[95] = cpu_inst.uPORT.ix1494.Q;
assign _sim_chain4_sobus[94] = cpu_inst.uPORT.ix1514.Q;
assign _sim_chain4_sobus[93] = cpu_inst.uPORT.ix1534.Q;
assign _sim_chain4_sobus[92] = cpu_inst.uPORT.ix1234.Q;
assign _sim_chain4_sobus[91] = cpu_inst.uPORT.ix1254.Q;
assign _sim_chain4_sobus[90] = cpu_inst.uPORT.ix1274.Q;
assign _sim_chain4_sobus[89] = cpu_inst.uPORT.ix1294.Q;
assign _sim_chain4_sobus[88] = cpu_inst.uPORT.ix1314.Q;
assign _sim_chain4_sobus[87] = cpu_inst.uPORT.ix1334.Q;
assign _sim_chain4_sobus[86] = cpu_inst.uPORT.ix1354.Q;
assign _sim_chain4_sobus[85] = cpu_inst.uPORT.ix1374.Q;
assign _sim_chain4_sobus[84] = cpu_inst.uPORT.ix701.Q;
assign _sim_chain4_sobus[83] = cpu_inst.uPORT.ix715.Q;
assign _sim_chain4_sobus[82] = cpu_inst.uPORT.ix729.Q;
assign _sim_chain4_sobus[81] = cpu_inst.uPORT.ix743.Q;
assign _sim_chain4_sobus[80] = cpu_inst.uPORT.ix757.Q;
assign _sim_chain4_sobus[79] = cpu_inst.uPORT.ix771.Q;
assign _sim_chain4_sobus[78] = cpu_inst.uPORT.ix785.Q;
assign _sim_chain4_sobus[77] = cpu_inst.uPORT.ix799.Q;
assign _sim_chain4_sobus[76] = cpu_inst.uPORT.ix813.Q;
assign _sim_chain4_sobus[75] = cpu_inst.uPORT.ix827.Q;
assign _sim_chain4_sobus[74] = cpu_inst.uPORT.ix841.Q;
assign _sim_chain4_sobus[73] = cpu_inst.uPORT.ix855.Q;
assign _sim_chain4_sobus[72] = cpu_inst.uPORT.ix869.Q;
assign _sim_chain4_sobus[71] = cpu_inst.uPORT.ix883.Q;
assign _sim_chain4_sobus[70] = cpu_inst.uPORT.ix897.Q;
assign _sim_chain4_sobus[69] = cpu_inst.uPORT.ix911.Q;
assign _sim_chain4_sobus[68] = cpu_inst.uPORT.ix925.Q;
assign _sim_chain4_sobus[67] = cpu_inst.uPORT.ix939.Q;
assign _sim_chain4_sobus[66] = cpu_inst.uPORT.ix953.Q;
assign _sim_chain4_sobus[65] = cpu_inst.uPORT.ix967.Q;
assign _sim_chain4_sobus[64] = cpu_inst.uPORT.ix981.Q;
assign _sim_chain4_sobus[63] = cpu_inst.uINTR.ix576.QB;
assign _sim_chain4_sobus[62] = cpu_inst.uINTR.ix86.QB;
assign _sim_chain4_sobus[61] = cpu_inst.uINTR.ix96.QB;
assign _sim_chain4_sobus[60] = cpu_inst.uINTR.ix116.QB;
assign _sim_chain4_sobus[59] = cpu_inst.uINTR.ix486.QB;
assign _sim_chain4_sobus[58] = cpu_inst.uINTR.ix496.QB;
assign _sim_chain4_sobus[57] = cpu_inst.uINTR.ix456.QB;
assign _sim_chain4_sobus[56] = cpu_inst.uINTR.ix466.QB;
assign _sim_chain4_sobus[55] = cpu_inst.uINTR.ix426.QB;
assign _sim_chain4_sobus[54] = cpu_inst.uINTR.ix436.QB;
assign _sim_chain4_sobus[53] = cpu_inst.uINTR.ix396.QB;
assign _sim_chain4_sobus[52] = cpu_inst.uINTR.ix406.QB;
assign _sim_chain4_sobus[51] = cpu_inst.uINTR.ix366.QB;
assign _sim_chain4_sobus[50] = cpu_inst.uINTR.ix376.QB;
assign _sim_chain4_sobus[49] = cpu_inst.uINTR.ix336.QB;
assign _sim_chain4_sobus[48] = cpu_inst.uINTR.ix346.QB;
assign _sim_chain4_sobus[47] = cpu_inst.uINTR.ix306.QB;
assign _sim_chain4_sobus[46] = cpu_inst.uINTR.ix316.QB;
assign _sim_chain4_sobus[45] = cpu_inst.uINTR.ix276.QB;
assign _sim_chain4_sobus[44] = cpu_inst.uINTR.ix286.QB;
assign _sim_chain4_sobus[43] = cpu_inst.uINTR.ix246.QB;
assign _sim_chain4_sobus[42] = cpu_inst.uINTR.ix256.QB;
assign _sim_chain4_sobus[41] = cpu_inst.uINTR.ix216.QB;
assign _sim_chain4_sobus[40] = cpu_inst.uINTR.ix226.QB;
assign _sim_chain4_sobus[39] = cpu_inst.uINTR.ix186.QB;
assign _sim_chain4_sobus[38] = cpu_inst.uINTR.ix196.QB;
assign _sim_chain4_sobus[37] = cpu_inst.uINTR.ix156.QB;
assign _sim_chain4_sobus[36] = cpu_inst.uINTR.ix166.QB;
assign _sim_chain4_sobus[35] = cpu_inst.uINTR.ix126.QB;
assign _sim_chain4_sobus[34] = cpu_inst.uINTR.ix136.QB;
assign _sim_chain4_sobus[33] = cpu_inst.uINTR.ix556.QB;
assign _sim_chain4_sobus[32] = cpu_inst.uINTR.ix566.QB;
assign _sim_chain4_sobus[31] = cpu_inst.uCNTR.ix1043.QB;
assign _sim_chain4_sobus[30] = cpu_inst.uCNTR.ix1083.Q;
assign _sim_chain4_sobus[29] = cpu_inst.uCNTR.ix1153.QB;
assign _sim_chain4_sobus[28] = cpu_inst.uCNTR.ix1143.Q;
assign _sim_chain4_sobus[27] = cpu_inst.uCNTR.ix973.Q;
assign _sim_chain4_sobus[26] = cpu_inst.uCNTR.ix993.Q;
assign _sim_chain4_sobus[25] = cpu_inst.uCNTR.ix1093.Q;
assign _sim_chain4_sobus[24] = cpu_inst.uCNTR.ix1073.Q;
assign _sim_chain4_sobus[23] = cpu_inst.uCNTR.ix1023.QB;
assign _sim_chain4_sobus[22] = cpu_inst.uCNTR.ix1133.QB;
assign _sim_chain4_sobus[21] = cpu_inst.uCNTR.ix1033.Q;
assign _sim_chain4_sobus[20] = cpu_inst.uCNTR.ix983.Q;
assign _sim_chain4_sobus[19] = cpu_inst.uUART.ix2091.Q;
assign _sim_chain4_sobus[18] = cpu_inst.uUART.ix2081.Q;
assign _sim_chain4_sobus[17] = cpu_inst.uUART.ix2171.QB;
assign _sim_chain4_sobus[16] = cpu_inst.uUART.ix2301.QB;
assign _sim_chain4_sobus[15] = cpu_inst.uUART.ix2491.QB;
assign _sim_chain4_sobus[14] = cpu_inst.uPDR.ix550.QB;
assign _sim_chain4_sobus[13] = cpu_inst.uPDR.ix560.QB;
assign _sim_chain4_sobus[12] = cpu_inst.uPDR.ix570.QB;
assign _sim_chain4_sobus[11] = cpu_inst.uPDR.ix580.QB;
assign _sim_chain4_sobus[10] = cpu_inst.uPDR.ix590.QB;
assign _sim_chain4_sobus[9] = cpu_inst.uPDR.ix600.QB;
assign _sim_chain4_sobus[8] = cpu_inst.uPDR.ix610.QB;
assign _sim_chain4_sobus[7] = cpu_inst.uPDR.ix620.QB;
assign _sim_chain4_sobus[6] = cpu_inst.uPDR.ix470.QB;
assign _sim_chain4_sobus[5] = cpu_inst.uPDR.ix480.QB;
assign _sim_chain4_sobus[4] = cpu_inst.uPDR.ix490.QB;
assign _sim_chain4_sobus[3] = cpu_inst.uPDR.ix500.QB;
assign _sim_chain4_sobus[2] = cpu_inst.uPDR.ix510.QB;
assign _sim_chain4_sobus[1] = cpu_inst.uPDR.ix520.QB;
assign _sim_chain4_sobus[0] = cpu_inst.uPDR.ix530.QB;

// Declare Variables for start of names in each chain
integer _chain1_start;
integer _chain2_start;
integer _chain3_start;
integer _chain4_start;

reg [255:0] _name_sobus[433:0];
initial $readmemh("pat_stuck_par.v.chain.name",_name_sobus,433,0);

event compare_exp_sim_chain1_sobus;
always @(compare_exp_sim_chain1_sobus) begin
 if (_do_compare) begin
  if ((_exp_chain1_sobus&_msk_chain1_sobus) !== (_sim_chain1_sobus&_msk_chain1_sobus)) begin
    $write($time, "ns: Simulated response for chain chain1: %b pattern %d cycle %d\n",_sim_chain1_sobus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response for chain chain1: %b pattern %d cycle %d\n",_exp_chain1_sobus,_pattern_count,_cycle_count);
    _report_bit_cnt = 100 + _par_shift_cnt;
    for(_bit_count = 0;
        ((_bit_count < 101)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
        _bit_count =_bit_count +1) begin
      if((_exp_chain1_sobus[_bit_count]&_msk_chain1_sobus[_bit_count]) !== (_sim_chain1_sobus[_bit_count]&_msk_chain1_sobus[_bit_count])) begin
        $write($time, "ns: Mismatch at chain chain1 cell %d name %s, Simulated %b, Expected %b\n",_report_bit_cnt,_name_sobus[(_chain1_start+_bit_count)],_sim_chain1_sobus[_bit_count],_exp_chain1_sobus[_bit_count]);
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_par.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_par.v)\n");
            $fwrite(_diag_file, "//format pattern\n");
            $fwrite(_diag_file, "//failure_buffer_limit_reached none\n");
            $fwrite(_diag_file, "//data_reference cell\n");
            $fwrite(_diag_file, "//pattern_id      chain/PO_name   cell_number   expected_value   simulated_value\n\n");
            _DIAG_file_header = 1;
          end
          if ((_chain_test_)&&(_diag_chain_header!=1)) begin
            $fwrite(_diag_file, "chain_test\n");
            _diag_chain_header = 1;
          end
          if ((_chain_test_!=1)&&(_diag_scan_header!=1)) begin
            $fwrite(_diag_file, "scan_test\n");
            _diag_scan_header = 1;
          end
          $fwrite(_diag_file, "%d  chain1 %d ", _pattern_count, _report_bit_cnt );
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin 
              _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          case ( _exp_chain1_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z"); 
                  end
          endcase
          case ( _sim_chain1_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // %s\n", _name_sobus[(_chain1_start+_bit_count)]);
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // %s\n", _name_sobus[(_chain1_start+_bit_count)]);
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // %s\n", _name_sobus[(_chain1_start+_bit_count)]);
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // %s\n", _name_sobus[(_chain1_start+_bit_count)]);
                  end
          endcase
        end
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_par.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
          if (_chain_test_ == 0) begin
            $fwrite(_mask_file, "%d %s %d\n",
             _pattern_count,"chain1",_report_bit_cnt);
          end
          if (_chain_test_ == 1) begin
            $fwrite(_mask_file, "// %d %s %d\n",
             _pattern_count,"chain1",_report_bit_cnt);
          end
        end
      end
       _report_bit_cnt = _report_bit_cnt - 1;
    end // End For
     _compare_fail = _compare_fail + 1;
   end
 end // if _do_compare
end


event compare_exp_sim_chain2_sobus;
always @(compare_exp_sim_chain2_sobus) begin
 if (_do_compare) begin
  if ((_exp_chain2_sobus&_msk_chain2_sobus) !== (_sim_chain2_sobus&_msk_chain2_sobus)) begin
    $write($time, "ns: Simulated response for chain chain2: %b pattern %d cycle %d\n",_sim_chain2_sobus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response for chain chain2: %b pattern %d cycle %d\n",_exp_chain2_sobus,_pattern_count,_cycle_count);
    _report_bit_cnt = 28 + _par_shift_cnt;
    for(_bit_count = 0;
        ((_bit_count < 29)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
        _bit_count =_bit_count +1) begin
      if((_exp_chain2_sobus[_bit_count]&_msk_chain2_sobus[_bit_count]) !== (_sim_chain2_sobus[_bit_count]&_msk_chain2_sobus[_bit_count])) begin
        $write($time, "ns: Mismatch at chain chain2 cell %d name %s, Simulated %b, Expected %b\n",_report_bit_cnt,_name_sobus[(_chain2_start+_bit_count)],_sim_chain2_sobus[_bit_count],_exp_chain2_sobus[_bit_count]);
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_par.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_par.v)\n");
            $fwrite(_diag_file, "//format pattern\n");
            $fwrite(_diag_file, "//failure_buffer_limit_reached none\n");
            $fwrite(_diag_file, "//data_reference cell\n");
            $fwrite(_diag_file, "//pattern_id      chain/PO_name   cell_number   expected_value   simulated_value\n\n");
            _DIAG_file_header = 1;
          end
          if ((_chain_test_)&&(_diag_chain_header!=1)) begin
            $fwrite(_diag_file, "chain_test\n");
            _diag_chain_header = 1;
          end
          if ((_chain_test_!=1)&&(_diag_scan_header!=1)) begin
            $fwrite(_diag_file, "scan_test\n");
            _diag_scan_header = 1;
          end
          $fwrite(_diag_file, "%d  chain2 %d ", _pattern_count, _report_bit_cnt );
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin 
              _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          case ( _exp_chain2_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z"); 
                  end
          endcase
          case ( _sim_chain2_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // %s\n", _name_sobus[(_chain2_start+_bit_count)]);
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // %s\n", _name_sobus[(_chain2_start+_bit_count)]);
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // %s\n", _name_sobus[(_chain2_start+_bit_count)]);
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // %s\n", _name_sobus[(_chain2_start+_bit_count)]);
                  end
          endcase
        end
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_par.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
          if (_chain_test_ == 0) begin
            $fwrite(_mask_file, "%d %s %d\n",
             _pattern_count,"chain2",_report_bit_cnt);
          end
          if (_chain_test_ == 1) begin
            $fwrite(_mask_file, "// %d %s %d\n",
             _pattern_count,"chain2",_report_bit_cnt);
          end
        end
      end
       _report_bit_cnt = _report_bit_cnt - 1;
    end // End For
     _compare_fail = _compare_fail + 1;
   end
 end // if _do_compare
end


event compare_exp_sim_chain3_sobus;
always @(compare_exp_sim_chain3_sobus) begin
 if (_do_compare) begin
  if ((_exp_chain3_sobus&_msk_chain3_sobus) !== (_sim_chain3_sobus&_msk_chain3_sobus)) begin
    $write($time, "ns: Simulated response for chain chain3: %b pattern %d cycle %d\n",_sim_chain3_sobus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response for chain chain3: %b pattern %d cycle %d\n",_exp_chain3_sobus,_pattern_count,_cycle_count);
    _report_bit_cnt = 151 + _par_shift_cnt;
    for(_bit_count = 0;
        ((_bit_count < 152)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
        _bit_count =_bit_count +1) begin
      if((_exp_chain3_sobus[_bit_count]&_msk_chain3_sobus[_bit_count]) !== (_sim_chain3_sobus[_bit_count]&_msk_chain3_sobus[_bit_count])) begin
        $write($time, "ns: Mismatch at chain chain3 cell %d name %s, Simulated %b, Expected %b\n",_report_bit_cnt,_name_sobus[(_chain3_start+_bit_count)],_sim_chain3_sobus[_bit_count],_exp_chain3_sobus[_bit_count]);
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_par.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_par.v)\n");
            $fwrite(_diag_file, "//format pattern\n");
            $fwrite(_diag_file, "//failure_buffer_limit_reached none\n");
            $fwrite(_diag_file, "//data_reference cell\n");
            $fwrite(_diag_file, "//pattern_id      chain/PO_name   cell_number   expected_value   simulated_value\n\n");
            _DIAG_file_header = 1;
          end
          if ((_chain_test_)&&(_diag_chain_header!=1)) begin
            $fwrite(_diag_file, "chain_test\n");
            _diag_chain_header = 1;
          end
          if ((_chain_test_!=1)&&(_diag_scan_header!=1)) begin
            $fwrite(_diag_file, "scan_test\n");
            _diag_scan_header = 1;
          end
          $fwrite(_diag_file, "%d  chain3 %d ", _pattern_count, _report_bit_cnt );
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin 
              _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          case ( _exp_chain3_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z"); 
                  end
          endcase
          case ( _sim_chain3_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // %s\n", _name_sobus[(_chain3_start+_bit_count)]);
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // %s\n", _name_sobus[(_chain3_start+_bit_count)]);
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // %s\n", _name_sobus[(_chain3_start+_bit_count)]);
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // %s\n", _name_sobus[(_chain3_start+_bit_count)]);
                  end
          endcase
        end
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_par.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
          if (_chain_test_ == 0) begin
            $fwrite(_mask_file, "%d %s %d\n",
             _pattern_count,"chain3",_report_bit_cnt);
          end
          if (_chain_test_ == 1) begin
            $fwrite(_mask_file, "// %d %s %d\n",
             _pattern_count,"chain3",_report_bit_cnt);
          end
        end
      end
       _report_bit_cnt = _report_bit_cnt - 1;
    end // End For
     _compare_fail = _compare_fail + 1;
   end
 end // if _do_compare
end


event compare_exp_sim_chain4_sobus;
always @(compare_exp_sim_chain4_sobus) begin
 if (_do_compare) begin
  if ((_exp_chain4_sobus&_msk_chain4_sobus) !== (_sim_chain4_sobus&_msk_chain4_sobus)) begin
    $write($time, "ns: Simulated response for chain chain4: %b pattern %d cycle %d\n",_sim_chain4_sobus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response for chain chain4: %b pattern %d cycle %d\n",_exp_chain4_sobus,_pattern_count,_cycle_count);
    _report_bit_cnt = 151 + _par_shift_cnt;
    for(_bit_count = 0;
        ((_bit_count < 152)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
        _bit_count =_bit_count +1) begin
      if((_exp_chain4_sobus[_bit_count]&_msk_chain4_sobus[_bit_count]) !== (_sim_chain4_sobus[_bit_count]&_msk_chain4_sobus[_bit_count])) begin
        $write($time, "ns: Mismatch at chain chain4 cell %d name %s, Simulated %b, Expected %b\n",_report_bit_cnt,_name_sobus[(_chain4_start+_bit_count)],_sim_chain4_sobus[_bit_count],_exp_chain4_sobus[_bit_count]);
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_par.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_par.v)\n");
            $fwrite(_diag_file, "//format pattern\n");
            $fwrite(_diag_file, "//failure_buffer_limit_reached none\n");
            $fwrite(_diag_file, "//data_reference cell\n");
            $fwrite(_diag_file, "//pattern_id      chain/PO_name   cell_number   expected_value   simulated_value\n\n");
            _DIAG_file_header = 1;
          end
          if ((_chain_test_)&&(_diag_chain_header!=1)) begin
            $fwrite(_diag_file, "chain_test\n");
            _diag_chain_header = 1;
          end
          if ((_chain_test_!=1)&&(_diag_scan_header!=1)) begin
            $fwrite(_diag_file, "scan_test\n");
            _diag_scan_header = 1;
          end
          $fwrite(_diag_file, "%d  chain4 %d ", _pattern_count, _report_bit_cnt );
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin 
              _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          case ( _exp_chain4_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z"); 
                  end
          endcase
          case ( _sim_chain4_sobus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // %s\n", _name_sobus[(_chain4_start+_bit_count)]);
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // %s\n", _name_sobus[(_chain4_start+_bit_count)]);
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // %s\n", _name_sobus[(_chain4_start+_bit_count)]);
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // %s\n", _name_sobus[(_chain4_start+_bit_count)]);
                  end
          endcase
        end
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_par.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_par.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
          if (_chain_test_ == 0) begin
            $fwrite(_mask_file, "%d %s %d\n",
             _pattern_count,"chain4",_report_bit_cnt);
          end
          if (_chain_test_ == 1) begin
            $fwrite(_mask_file, "// %d %s %d\n",
             _pattern_count,"chain4",_report_bit_cnt);
          end
        end
      end
       _report_bit_cnt = _report_bit_cnt - 1;
    end // End For
     _compare_fail = _compare_fail + 1;
   end
 end // if _do_compare
end

`ifdef VCD
  initial begin
    $dumpfile("pat_stuck_par.v.dump");
    $dumpvars;
  end
`endif

`ifdef UTVCD
  initial begin
    $dumpfile("pat_stuck_par.v.dump");
    $vtDump;
    $dumpvars;
  end
`endif

`ifdef debussy
  initial begin
    $fsdbDumpfile("pat_stuck_par.v.fsdb");
    $fsdbDumpvars;
  end
`endif

reg[458:0]     mem [0:3426];
cpu cpu_inst (.PORT0I({\PORT0I[7]  , \PORT0I[6] 
     , \PORT0I[5] , \PORT0I[4] , \PORT0I[3] 
     , \PORT0I[2] , \PORT0I[1] , \PORT0I[0] 
     }),.PORT1I({\PORT1I[7]  , \PORT1I[6] 
     , \PORT1I[5] , \PORT1I[4] , \PORT1I[3] 
     , \PORT1I[2] , \PORT1I[1] , \PORT1I[0] 
     }),.PORT2I({\PORT2I[7]  , \PORT2I[6] 
     , \PORT2I[5] , \PORT2I[4] , \PORT2I[3] 
     , \PORT2I[2] , \PORT2I[1] , \PORT2I[0] 
     }),.PORT3I({\PORT3I[7]  , \PORT3I[6] 
     , \PORT3I[5] , \PORT3I[4] , \PORT3I[3] 
     , \PORT3I[2] , \PORT3I[1] , \PORT3I[0] 
     }),.PROGDI({\PROGDI[7]  , \PROGDI[6] 
     , \PROGDI[5] , \PROGDI[4] , \PROGDI[3] 
     , \PROGDI[2] , \PROGDI[1] , \PROGDI[0] 
     }),.XRAMDI({\XRAMDI[7]  , \XRAMDI[6] 
     , \XRAMDI[5] , \XRAMDI[4] , \XRAMDI[3] 
     , \XRAMDI[2] , \XRAMDI[1] , \XRAMDI[0] 
     }),.SOURCE_DI({\SOURCE_DI[7]  
     , \SOURCE_DI[6] , \SOURCE_DI[5] 
     , \SOURCE_DI[4] , \SOURCE_DI[3] 
     , \SOURCE_DI[2] , \SOURCE_DI[1] 
     , \SOURCE_DI[0] }),.ESFRDI({\ESFRDI[7]  
     , \ESFRDI[6] , \ESFRDI[5] , \ESFRDI[4] 
     , \ESFRDI[3] , \ESFRDI[2] , \ESFRDI[1] 
     , \ESFRDI[0] }),.XINTR_SRC({\XINTR_SRC[13]  
     , \XINTR_SRC[12] , \XINTR_SRC[11] 
     , \XINTR_SRC[10] , \XINTR_SRC[9] 
     , \XINTR_SRC[8] , \XINTR_SRC[7] 
     , \XINTR_SRC[6] , \XINTR_SRC[5]  }), .MWAIT(MWAIT), 
     .CLK1(CLK1), .CLK2(CLK2), .CLK3(CLK3), .RESET(RESET), 
     .TRESET(TRESET), .scan_in1(scan_in1), .scan_in2(scan_in2), 
     .scan_in3(scan_in3), .scan_in4(scan_in4), .scan_en(scan_en), 
     .PORT0O({\PORT0O[7] , \PORT0O[6] , \PORT0O[5] 
     , \PORT0O[4] , \PORT0O[3] , \PORT0O[2] 
     , \PORT0O[1] , \PORT0O[0] }), .PORT1O({\PORT1O[7] 
     , \PORT1O[6] , \PORT1O[5] , \PORT1O[4] 
     , \PORT1O[3] , \PORT1O[2] , \PORT1O[1] 
     , \PORT1O[0] }), .PORT2O({\PORT2O[7] , \PORT2O[6] 
     , \PORT2O[5] , \PORT2O[4] , \PORT2O[3] 
     , \PORT2O[2] , \PORT2O[1] , \PORT2O[0] 
     }), .PORT3O({\PORT3O[7] , \PORT3O[6] , \PORT3O[5] 
     , \PORT3O[4] , \PORT3O[3] , \PORT3O[2] 
     , \PORT3O[1] , \PORT3O[0] }), .NPORT1E({\NPORT1E[7] 
     , \NPORT1E[6] , \NPORT1E[5] , \NPORT1E[4] 
     , \NPORT1E[3] , \NPORT1E[2] , \NPORT1E[1] 
     , \NPORT1E[0] }), .NPORT2E({\NPORT2E[7] 
     , \NPORT2E[6] , \NPORT2E[5] , \NPORT2E[4] 
     , \NPORT2E[3] , \NPORT2E[2] , \NPORT2E[1] 
     , \NPORT2E[0] }), .NPORT3E({\NPORT3E[7] 
     , \NPORT3E[6] , \NPORT3E[5] , \NPORT3E[4] 
     , \NPORT3E[3] , \NPORT3E[2] , \NPORT3E[1] 
     , \NPORT3E[0] }), .XRAMDO({\XRAMDO[7] 
     , \XRAMDO[6] , \XRAMDO[5] , \XRAMDO[4] 
     , \XRAMDO[3] , \XRAMDO[2] , \XRAMDO[1] 
     , \XRAMDO[0] }), .PROGA({\PROGA[15] , \PROGA[14] 
     , \PROGA[13] , \PROGA[12] , \PROGA[11] 
     , \PROGA[10] , \PROGA[9] , \PROGA[8] , \PROGA[7] 
     , \PROGA[6] , \PROGA[5] , \PROGA[4] , \PROGA[3] 
     , \PROGA[2] , \PROGA[1] , \PROGA[0] }), .XRAMA({\XRAMA[15] 
     , \XRAMA[14] , \XRAMA[13] , \XRAMA[12] 
     , \XRAMA[11] , \XRAMA[10] , \XRAMA[9] , \XRAMA[8] 
     , \XRAMA[7] , \XRAMA[6] , \XRAMA[5] , \XRAMA[4] 
     , \XRAMA[3] , \XRAMA[2] , \XRAMA[1] , \XRAMA[0] 
     }), .NPSEN(NPSEN), .NXRAMR(NXRAMR), .NXRAMW(NXRAMW), 
     .PROGA_EN(PROGA_EN), .XRAMA_EN(XRAMA_EN), 
     .SOURCE_A({\SOURCE_A[7] , \SOURCE_A[6] 
     , \SOURCE_A[5] , \SOURCE_A[4] , \SOURCE_A[3] 
     , \SOURCE_A[2] , \SOURCE_A[1] , \SOURCE_A[0] 
     }), .DESTIN_A({\DESTIN_A[7] , \DESTIN_A[6] 
     , \DESTIN_A[5] , \DESTIN_A[4] , \DESTIN_A[3] 
     , \DESTIN_A[2] , \DESTIN_A[1] , \DESTIN_A[0] 
     }), .DESTIN_DO({\DESTIN_DO[7] , \DESTIN_DO[6] 
     , \DESTIN_DO[5] , \DESTIN_DO[4] , \DESTIN_DO[3] 
     , \DESTIN_DO[2] , \DESTIN_DO[1] , \DESTIN_DO[0] 
     }), .NDESTIN_WE(NDESTIN_WE), .NSOURCE_RE(NSOURCE_RE), 
     .SFRWE(SFRWE), .SFRSA({\SFRSA[6] , \SFRSA[5] 
     , \SFRSA[4] , \SFRSA[3] , \SFRSA[2] , \SFRSA[1] 
     , \SFRSA[0] }), .XINTR_ACK({\XINTR_ACK[13] 
     , \XINTR_ACK[12] , \XINTR_ACK[11] 
     , \XINTR_ACK[10] , \XINTR_ACK[9] 
     , \XINTR_ACK[8] , \XINTR_ACK[7] , \XINTR_ACK[6] 
     , \XINTR_ACK[5] }), .IDLE(IDLE), .PDOWN(PDOWN), 
     .NCCLKE(NCCLKE), .NPCLKE(NPCLKE), .scan_out1(scan_out1));

initial begin
_compare_fail = 0;
_pattern_count = 0;
_cycle_count = 0;
_save_cycle_count = 0;
_write_DIAG_file = 0; // change to 1, to generate file
_write_MASK_file = 0; // change to 1, to generate file
_DIAG_file_header = 0;
_diag_file = 0;
_diag_chain_header = 0;
_diag_scan_header = 0;
_fail_pattern_cnt = 0;
_last_fail_pattern = 0;
_MASK_file_header = 0;
_mask_file = 0;
_chain_test_ = 0;
_par_shift_cnt = 0;
_report_bit_cnt = 0;
// Limit # of miscompares before aborting simulation (non-zero)
_miscompare_limit = 0; 
_end_vec_file_ok = 0; 
_msk_chain1_sobus=101'b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111;
_msk_chain2_sobus=29'b11111111111111111111111111111;
_msk_chain3_sobus=152'b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111;
_msk_chain4_sobus=152'b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111;
_run_testsetup  = 0;
_start_pat      = -1;
_end_pat        = -1;
_pat_num        = -1;
_in_range       = 1;
_do_compare     = 1;
_in_chaintest   = 0;

_skipped_patterns = 0;

_end_simulation   = 0;

if ($value$plusargs("STARTPAT=%d", _start_pat)) begin
  $display(" Found Start pattern number %d", _start_pat);
  _in_range = 0;
  _do_compare = 0;
end
if ($value$plusargs("ENDPAT=%d", _end_pat)) begin
  $display(" Found End pattern number   %d", _end_pat);
end

if ($value$plusargs("CHAINTEST=%d", _in_chaintest)) begin
  if (_in_chaintest) begin
    $display(" Found ChainTest identifier %d", _in_chaintest);
  end
end

 _chain1_start = 333;  // 101
 _chain2_start = 304;  // 29
 _chain3_start = 152;  // 152
 _chain4_start = 0;  // 152

// read vector config file
_config_file = $fopen("pat_stuck_par.v.cfg", "r");
if (_config_file == 0) begin
  $display("ERROR: Couldn't open configuration file, simulation aborted\n");
  $finish;
end
_fstat = 0;
if (_start_pat != -1) begin
  if (_in_chaintest == 0) begin
  $display("BEGIN pattern read loop  Start pattern (%d) End pattern (%d)\n",
_start_pat,_end_pat);
  end
  else begin
  $display("BEGIN pattern read loop  Start chain pattern (%d) End chain pattern (%d)\n",
_start_pat,_end_pat);
  end
end
else if (_end_pat != -1) begin
  if (_in_chaintest == 0) begin
  $display("BEGIN pattern read loop  End pattern (%d)\n", _end_pat);
  end
  else begin
  $display("BEGIN pattern read loop  End chain pattern (%d)\n", _end_pat);
  end
end

// begin pattern read loop
while (!$feof(_config_file))
begin
         _fstat = $fscanf(_config_file, "%s", _vec_file_name);
         _fstat = $fscanf(_config_file, "%d", _max_index);
   if (_fstat != -1) begin
          $display("Loading %0s\n", _vec_file_name);
          $readmemb(_vec_file_name, mem, 0, _max_index);
         _end_vec_file_ok = 0;
   end
   else begin
     _max_index = -1;
   end
   _scan_index = 0;
   _repeat_count = 0;
   _message_index = 0;
   _save_index = 0;
   for (_index=0; _index <= _max_index; _index = _index+1)
   begin
      vect = mem[_index];
      _exp_obus=149'bXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;
      _msk_obus=149'b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000;
      _MGCDFT_VECTYPE = vect[3:0];
      _pat_type = vect[6:4];
      _tp_num = vect[7];
      //    Range Check
      if ((_start_pat != -1)&&
          ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
        if ((_pat_num == _start_pat) && !_in_range) begin
          _in_range = 1;
          _do_compare = 0;
          _pattern_count = (_pat_num - 1);
          if (_pattern_count < 0) begin
            _pattern_count = 0;
          end
        end
        if (_pat_num == (_start_pat + 1)) begin
          _do_compare = 1;
        end
      end

      if ((_end_pat != -1) && (_pattern_count > _end_pat) && 
          ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
         // simulation complete, exit
         _index = _max_index + 1;
         _end_vec_file_ok = 1;
         _end_simulation = 1;
      end
      if ((_in_range) || (_run_testsetup)) begin
      case (_pat_type)
         3'b000:  begin // end vector
            _index = _max_index + 1;
         end // end vector
         3'b001: ;// skip scan vector, handled by shift vector
         3'b010:  begin // broadside vector
            if (vect[8] == 1'b1) begin
               _pattern_count = _pattern_count + 1;
               _par_shift_cnt = 0;
              if ((!_do_compare) && (_pattern_count >= _start_pat)) begin
                _do_compare = 1;
              end
              if ((_end_pat != -1) && (_pattern_count > _end_pat) && 
                  ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
                // simulation complete, exit
                _index = _max_index + 1;
                _end_vec_file_ok = 1;
                _end_simulation = 1;
                _in_range = 0;
              end
            end
            if (vect[8] === 1'bz) begin
               _pattern_count = 0;
               _par_shift_cnt = 0;
            end
            case (_tp_num)
               1'b1: begin // timeplate 1 - gen_tp1
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;
                  _ibus[83:10] = vect[390:317];
                  _ibus[4:0] = vect[311:307];

                  #10; // 10 ns
                  _exp_obus[148:0] = vect[306:158];
                  _msk_obus[148:0] = vect[157:9];
                  #0;
                  ->compare_exp_sim_obus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                      if (_DIAG_file_header == 1) begin
                         if (_diag_scan_header==1) begin
                           $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                         end
                         $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                         $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                         $fwrite(_diag_file, "failure_file_end\n");
                         $fclose(_diag_file);
                      end
                      $finish;
                  end

                  #10; // 20 ns
                  _ibus[9:5] = vect[316:312];

                  #10; // 30 ns
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;

                  #10; // 40 ns
               end // timeplate 1 - gen_tp1
               default: begin
                  $display("ERROR: corrupt timeplate number\n");
                  $finish;
               end
            endcase // _tp_num
            _cycle_count = _cycle_count + 1;
            _par_shift_cnt = 0;
         end // broadside vector
         3'b011:  begin // shift vector for grp1
            if (vect[8] == 1'b1) begin
               _pattern_count = _pattern_count + 1;
             _par_shift_cnt = 0;
              if ((_end_pat != -1) && (_pattern_count > _end_pat) && 
                  ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
                // simulation complete, exit
                _index = _max_index + 1;
                _end_vec_file_ok = 1;
                _end_simulation = 1;
                _in_range = 0;
              end
            end
            if (vect[8] === 1'bz) begin
               _pattern_count = 0;
             _par_shift_cnt = 0;
            end
            case (_tp_num)
               1'b1: begin // timeplate 1 - gen_tp1
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;
                  _ibus[83:10] = vect[390:317];
                  _ibus[4:0] = vect[311:307];
                  mem_vect = mem[_index+1];
                  _frc_chain1_sibus[100:0] = mem_vect[305:205];
                  _exp_chain1_sobus[100:0] = mem_vect[204:104];
                  _msk_chain1_sobus[100:0] = mem_vect[103:3];
                  mem_vect = mem[_index+2];
                  _frc_chain2_sibus[28:0] = mem_vect[89:61];
                  _exp_chain2_sobus[28:0] = mem_vect[60:32];
                  _msk_chain2_sobus[28:0] = mem_vect[31:3];
                  mem_vect = mem[_index+3];
                  _frc_chain3_sibus[151:0] = mem_vect[458:307];
                  _exp_chain3_sobus[151:0] = mem_vect[306:155];
                  _msk_chain3_sobus[151:0] = mem_vect[154:3];
                  mem_vect = mem[_index+4];
                  _frc_chain4_sibus[151:0] = mem_vect[458:307];
                  _exp_chain4_sobus[151:0] = mem_vect[306:155];
                  _msk_chain4_sobus[151:0] = mem_vect[154:3];

                  #10; // 10 ns
                  _exp_obus[148:0] = vect[306:158];
                  _msk_obus[148:0] = vect[157:9];
                  #0;
                  ->compare_exp_sim_obus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                      if (_DIAG_file_header == 1) begin
                         if (_diag_scan_header==1) begin
                           $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                         end
                         $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                         $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                         $fwrite(_diag_file, "failure_file_end\n");
                         $fclose(_diag_file);
                      end
                      $finish;
                  end
                  #0;
                  -> compare_exp_sim_chain1_sobus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                    if (_DIAG_file_header == 1) begin
                       if (_diag_scan_header==1) begin
                         $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                       end
                       $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                       $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                       $fwrite(_diag_file, "failure_file_end\n");
                       $fclose(_diag_file);
                    end
                    $finish;
                  end
                  #0;
                  -> compare_exp_sim_chain2_sobus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                    if (_DIAG_file_header == 1) begin
                       if (_diag_scan_header==1) begin
                         $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                       end
                       $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                       $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                       $fwrite(_diag_file, "failure_file_end\n");
                       $fclose(_diag_file);
                    end
                    $finish;
                  end
                  #0;
                  -> compare_exp_sim_chain3_sobus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                    if (_DIAG_file_header == 1) begin
                       if (_diag_scan_header==1) begin
                         $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                       end
                       $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                       $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                       $fwrite(_diag_file, "failure_file_end\n");
                       $fclose(_diag_file);
                    end
                    $finish;
                  end
                  #0;
                  -> compare_exp_sim_chain4_sobus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                    if (_DIAG_file_header == 1) begin
                       if (_diag_scan_header==1) begin
                         $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                       end
                       $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                       $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                       $fwrite(_diag_file, "failure_file_end\n");
                       $fclose(_diag_file);
                    end
                    $finish;
                  end

                  #1; // 11 ns
                  -> force_frc_chain1_sibus;
                  -> force_frc_chain2_sibus;
                  -> force_frc_chain3_sibus;
                  -> force_frc_chain4_sibus;

                  #9; // 20 ns
                  _ibus[9:5] = vect[316:312];

                  #10; // 30 ns
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;

                  #10; // 40 ns
                  -> release_frc_chain1_sibus;
                  #0;
                  -> release_frc_chain2_sibus;
                  #0;
                  -> release_frc_chain3_sibus;
                  #0;
                  -> release_frc_chain4_sibus;
                  #0;
                  _index = _index + 4;
               end // timeplate 1 - gen_tp1
               default: begin
                  $display("ERROR: corrupt timeplate number\n");
                  $finish;
               end
            endcase // _tp_num
            _cycle_count = _cycle_count + 1;
            _par_shift_cnt = _par_shift_cnt + 1;
         end // shift vector
         3'b100:  begin // status message vector
            _message_index = vect[38:7];
            case (_message_index)
               0: begin
                  $display("Begin chain test\n");
                 _chain_test_ = 1;
                  _diag_chain_header = 0;
               end
               1: begin
                  $display("End chain test\n");
                 _chain_test_ = 0;
                  if (_diag_chain_header) begin
                    $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
                  end
                  _diag_scan_header = 0;
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                        $display("Simulated chain pattern %d\n",_pat_num);
                    end
                  end
                  _pat_num = -1;
                  _pattern_count = 0;
                  if (_in_chaintest) begin
                    _index = _max_index + 1;
                    _end_vec_file_ok = 1;
                    _end_simulation = 1;
                    _in_range = 0;
                  end
               end
               2: begin
                  $display("Status update: simulated through pattern %d\n",_pattern_count);
               end
               3: begin
                  _end_vec_file_ok = 1;
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                      if (!_chain_test_) begin
                        $display("Simulated pattern %d\n",_pat_num);
                      end
                    end
                  end
               end
               4: begin // start of atpg pattern
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                      if (_chain_test_) begin
                        $display("Simulated chain pattern %d\n",_pat_num);
                      end
                      else begin
                        $display("Simulated pattern %d\n",_pat_num);
                      end
                    end
                  end
                  _pat_num = _pat_num + 1;
                  _run_testsetup  = 0;
               end
               default: begin
                  $display("ERROR: corrupt message index\n");
                  $finish;
               end
            endcase // _message_index
         end
         default: begin
            $display("ERROR: corrupt vector number\n");
            $finish;
         end
      endcase
   end // if in_range
      else begin
      case (_pat_type)  // _pat_type = vect[6:4]; 
         3'b011:  begin // shift vector for grp1
                  _index = _index + 4;
         end // shift vector
         3'b100:  begin // status message vector
            _message_index = vect[38:7]; 
            case (_message_index)
               0: begin
                  _chain_test_ = 1;
                  _diag_chain_header = 0;
               end
               1: begin
                  if (_pat_num > -1) begin
                    $display("Skipped chain pattern %d\n",_pat_num);
                  end
                  _chain_test_ = 0;
                  _pat_num = -1;
                  if (_in_chaintest) begin
                    _index = _max_index + 1;
                    _end_vec_file_ok = 1;
                    _end_simulation = 1;
                    _in_range = 0;
                  end
               end
               3: begin 
                  _end_vec_file_ok = 1;
                  if (_pat_num > -1) begin
                    if (!_chain_test_) begin
                      $display("Skipped pattern %d\n",_pat_num);
                    end
                  end
               end
               4: begin // start of atpg pattern
                  if (_pat_num > -1) begin
                    if (!_chain_test_) begin
                      _skipped_patterns = _skipped_patterns + 1;
                    end
                  end
                  if (_pat_num > -1) begin
                    if (_chain_test_) begin
                      $display("Skipped chain pattern %d\n",_pat_num);
                    end
                    else begin
                      $display("Skipped pattern %d\n",_pat_num);
                    end
                  end
                  _pat_num = _pat_num + 1;
                  _run_testsetup  = 0;
               end
               default: begin
                  // Skip
               end
            endcase // _message_index
         end
         default: begin
            // Skip
         end
      endcase
      end // else !_in_range
   end // index loop
end // file_cnt loop
 if (_DIAG_file_header == 1) begin
    if (_diag_scan_header==1) begin
      $fwrite(_diag_file, "last_pattern_applied %d\n", _pattern_count);
    end
    $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
    $fwrite(_diag_file, " simulation_time=", $time, ";\n");
    $fwrite(_diag_file, "failure_file_end\n");
    $fclose(_diag_file);
 end


#1;
if (_end_vec_file_ok == 0) begin
  $display("ERROR: Pattern file corrupted, simulation aborted\n");
end
if ((_end_vec_file_ok) && (_compare_fail == 0)) begin
   $display("No error between simulated and expected patterns\n");
end

#1;
$finish;
end
endmodule
