// Go to DFT mode
set_context dft -scan
read_verilog ../netlists/cpu_gate.v
read_cell_library ../libs/adk.atpg
analyze_control_signals -auto
set_system_mode analysis
// Insert scan and ensure dedicated scan output pins
insert_test_logic -scan on -number 20
report_scan_chains
// Write netlist and setup files for Tessent FastScan and TestKompress
write_design -output_file ../netlists/cpu_scan.v -replace
write_atpg_setup ../2_fs_pg/cpu_scan -replace
write_atpg_setup ../3_tk_edt/cpu_scan -replace
exit -d
