set_context dft -edt
read_verilog ../netlists/cpu_scan.v
read_cell_library ../libs/adk.atpg
set_current_design cpu
// Read atpg setup
dofile cpu_scan.dofile
//Settings for EDT
set_edt_options -input_channels 4 -output_channels 4
// Go to atpg mode
set_system_mode analysis
//Create Patterns as a sanity check to make sure that you are getting the same coverage as FastScan
create_patterns
//Save the EDT logic and write out the synthesis scripts.
write_edt_files ../5_tk_pg/cpu_edt -verilog -replace
report_edt_configuration
exit -d
