set_context patterns -scan
read_verilog ./netlist/c1.v
set_current_design c1
set_system_mode analysis

set_fault_type stuck // set stuck-at fault model
add_faults -all

set_pattern_source external ./patt/p6_e0f0_g0.ascii -ascii
simulate_patterns
report_statistics > ./patt/p6_e0f0_g0.fa
report_faults -class detected >> ./patt/p6_e0f0_g0.fa

reset_state
set_pattern_source external ./patt/p6_e0g0_f0.ascii -ascii
simulate_patterns
report_statistics > ./patt/p6_e0g0_f0.fa
report_faults -class detected >> ./patt/p6_e0g0_f0.fa
exit -d
