//
// Verilog format test patterns produced by Tessent Shell 2013.4
// Filename       : ../3_vsim/pat_stuck_ser.v
// Scan operation : SERIAL
// Idstamp        : 2013.4:9756:f974:423:cf33
// Fault          : STUCK
// Coverage       : 99.94(TC) 98.47(FC)
// Date           : Fri Dec 27 14:13:09 2013
//
// Begin_Verify_Section 
//   format            = Verilog 
//   top_module_name   = cpu_pat_stuck_ser_v_ctl 
//   serial_flag       = ON 
//   test_set_type     = ALL_TEST 
//   pad_value         = X 
//   pattern_begin     = 0 
//   pattern_end       = 2 
//   one_setup         = ON 
//   no_initialization = OFF 
//   pattern_checksum  = 10782 
// End_Verify_Section 

`timescale 1ns / 1ns

module cpu_pat_stuck_ser_v_ctl;

integer     _wrote_fail;
integer     _write_DIAG_file;
integer     _DIAG_file_header;
integer     _diag_file;
integer     _diag_chain_header;
integer     _diag_scan_header;
integer     _last_fail_pattern;
integer     _fail_pattern_cnt;
integer     _write_MASK_file;
integer     _MASK_file_header;
integer     _mask_file;
integer     _par_shift_cnt;
integer     _chain_test_;
integer     _compare_fail;
integer     _bit_count;
integer     _report_bit_cnt;
integer     _miscompare_limit;
integer     _found_fail;
integer     _end_vec_file_ok;
integer     _cycle_count, _save_cycle_count;
integer     _pattern_count, _repeat_count, _message_index;
integer     _index, _scan_index, _file_cnt, _max_index, _save_index;
integer     _file_check;
integer     _run_testsetup;
integer     _start_pat;
integer     _end_pat;
integer     _in_range;
integer     _do_compare;
integer     _in_chaintest;
integer     _pat_num;
integer     _skipped_patterns;
integer     _end_simulation;
integer     _config_file;
integer     _fstat;
integer     _max_file_cnt;
reg[256*8:1] _vec_file_name;
integer     _scan_shift_count;
reg[83:0]    _ibus;
reg[148:0]    _exp_obus, _msk_obus;
wire[148:0]   _sim_obus;
reg[2:0]    _pat_type;
reg         _tp_num;
reg[390:0]   vect;

wire \PORT0I[7] , \PORT0I[6] , \PORT0I[5] , \PORT0I[4] , \PORT0I[3] , 
     \PORT0I[2] , \PORT0I[1] , \PORT0I[0] , \PORT1I[7] , \PORT1I[6] , 
     \PORT1I[5] , \PORT1I[4] , \PORT1I[3] , \PORT1I[2] , \PORT1I[1] , 
     \PORT1I[0] , \PORT2I[7] , \PORT2I[6] , \PORT2I[5] , \PORT2I[4] , 
     \PORT2I[3] , \PORT2I[2] , \PORT2I[1] , \PORT2I[0] , \PORT3I[7] , 
     \PORT3I[6] , \PORT3I[5] , \PORT3I[4] , \PORT3I[3] , \PORT3I[2] , 
     \PORT3I[1] , \PORT3I[0] , \PROGDI[7] , \PROGDI[6] , \PROGDI[5] , 
     \PROGDI[4] , \PROGDI[3] , \PROGDI[2] , \PROGDI[1] , \PROGDI[0] , 
     \XRAMDI[7] , \XRAMDI[6] , \XRAMDI[5] , \XRAMDI[4] , \XRAMDI[3] , 
     \XRAMDI[2] , \XRAMDI[1] , \XRAMDI[0] , \SOURCE_DI[7] , \SOURCE_DI[6] , 
     \SOURCE_DI[5] , \SOURCE_DI[4] , \SOURCE_DI[3] , \SOURCE_DI[2] , 
     \SOURCE_DI[1] , \SOURCE_DI[0] , \ESFRDI[7] , \ESFRDI[6] , \ESFRDI[5] , 
     \ESFRDI[4] , \ESFRDI[3] , \ESFRDI[2] , \ESFRDI[1] , \ESFRDI[0] , 
     \XINTR_SRC[13] , \XINTR_SRC[12] , \XINTR_SRC[11] , \XINTR_SRC[10] , 
     \XINTR_SRC[9] , \XINTR_SRC[8] , \XINTR_SRC[7] , \XINTR_SRC[6] , 
     \XINTR_SRC[5] , MWAIT, CLK1, CLK2, CLK3, RESET, TRESET, scan_in1, 
     scan_in2, scan_in3, scan_in4, scan_en, \PORT0O[7] , \PORT0O[6] , 
     \PORT0O[5] , \PORT0O[4] , \PORT0O[3] , \PORT0O[2] , \PORT0O[1] , 
     \PORT0O[0] , \PORT1O[7] , \PORT1O[6] , \PORT1O[5] , \PORT1O[4] , 
     \PORT1O[3] , \PORT1O[2] , \PORT1O[1] , \PORT1O[0] , \PORT2O[7] , 
     \PORT2O[6] , \PORT2O[5] , \PORT2O[4] , \PORT2O[3] , \PORT2O[2] , 
     \PORT2O[1] , \PORT2O[0] , \PORT3O[7] , \PORT3O[6] , \PORT3O[5] , 
     \PORT3O[4] , \PORT3O[3] , \PORT3O[2] , \PORT3O[1] , \PORT3O[0] , 
     \NPORT1E[7] , \NPORT1E[6] , \NPORT1E[5] , \NPORT1E[4] , \NPORT1E[3] , 
     \NPORT1E[2] , \NPORT1E[1] , \NPORT1E[0] , \NPORT2E[7] , \NPORT2E[6] , 
     \NPORT2E[5] , \NPORT2E[4] , \NPORT2E[3] , \NPORT2E[2] , \NPORT2E[1] , 
     \NPORT2E[0] , \NPORT3E[7] , \NPORT3E[6] , \NPORT3E[5] , \NPORT3E[4] , 
     \NPORT3E[3] , \NPORT3E[2] , \NPORT3E[1] , \NPORT3E[0] , \XRAMDO[7] , 
     \XRAMDO[6] , \XRAMDO[5] , \XRAMDO[4] , \XRAMDO[3] , \XRAMDO[2] , 
     \XRAMDO[1] , \XRAMDO[0] , \PROGA[15] , \PROGA[14] , \PROGA[13] , 
     \PROGA[12] , \PROGA[11] , \PROGA[10] , \PROGA[9] , \PROGA[8] , 
     \PROGA[7] , \PROGA[6] , \PROGA[5] , \PROGA[4] , \PROGA[3] , \PROGA[2] , 
     \PROGA[1] , \PROGA[0] , \XRAMA[15] , \XRAMA[14] , \XRAMA[13] , 
     \XRAMA[12] , \XRAMA[11] , \XRAMA[10] , \XRAMA[9] , \XRAMA[8] , 
     \XRAMA[7] , \XRAMA[6] , \XRAMA[5] , \XRAMA[4] , \XRAMA[3] , \XRAMA[2] , 
     \XRAMA[1] , \XRAMA[0] , NPSEN, NXRAMR, NXRAMW, PROGA_EN, XRAMA_EN, 
     \SOURCE_A[7] , \SOURCE_A[6] , \SOURCE_A[5] , \SOURCE_A[4] , \SOURCE_A[3] , 
     \SOURCE_A[2] , \SOURCE_A[1] , \SOURCE_A[0] , \DESTIN_A[7] , \DESTIN_A[6] , 
     \DESTIN_A[5] , \DESTIN_A[4] , \DESTIN_A[3] , \DESTIN_A[2] , \DESTIN_A[1] , 
     \DESTIN_A[0] , \DESTIN_DO[7] , \DESTIN_DO[6] , \DESTIN_DO[5] , 
     \DESTIN_DO[4] , \DESTIN_DO[3] , \DESTIN_DO[2] , \DESTIN_DO[1] , 
     \DESTIN_DO[0] , NDESTIN_WE, NSOURCE_RE, SFRWE, \SFRSA[6] , \SFRSA[5] , 
     \SFRSA[4] , \SFRSA[3] , \SFRSA[2] , \SFRSA[1] , \SFRSA[0] , \XINTR_ACK[13] , 
     \XINTR_ACK[12] , \XINTR_ACK[11] , \XINTR_ACK[10] , \XINTR_ACK[9] , 
     \XINTR_ACK[8] , \XINTR_ACK[7] , \XINTR_ACK[6] , \XINTR_ACK[5] , 
     IDLE, PDOWN, NCCLKE, NPCLKE, scan_out1;

assign \PORT0I[7]  = _ibus[83];
assign \PORT0I[6]  = _ibus[82];
assign \PORT0I[5]  = _ibus[81];
assign \PORT0I[4]  = _ibus[80];
assign \PORT0I[3]  = _ibus[79];
assign \PORT0I[2]  = _ibus[78];
assign \PORT0I[1]  = _ibus[77];
assign \PORT0I[0]  = _ibus[76];
assign \PORT1I[7]  = _ibus[75];
assign \PORT1I[6]  = _ibus[74];
assign \PORT1I[5]  = _ibus[73];
assign \PORT1I[4]  = _ibus[72];
assign \PORT1I[3]  = _ibus[71];
assign \PORT1I[2]  = _ibus[70];
assign \PORT1I[1]  = _ibus[69];
assign \PORT1I[0]  = _ibus[68];
assign \PORT2I[7]  = _ibus[67];
assign \PORT2I[6]  = _ibus[66];
assign \PORT2I[5]  = _ibus[65];
assign \PORT2I[4]  = _ibus[64];
assign \PORT2I[3]  = _ibus[63];
assign \PORT2I[2]  = _ibus[62];
assign \PORT2I[1]  = _ibus[61];
assign \PORT2I[0]  = _ibus[60];
assign \PORT3I[7]  = _ibus[59];
assign \PORT3I[6]  = _ibus[58];
assign \PORT3I[5]  = _ibus[57];
assign \PORT3I[4]  = _ibus[56];
assign \PORT3I[3]  = _ibus[55];
assign \PORT3I[2]  = _ibus[54];
assign \PORT3I[1]  = _ibus[53];
assign \PORT3I[0]  = _ibus[52];
assign \PROGDI[7]  = _ibus[51];
assign \PROGDI[6]  = _ibus[50];
assign \PROGDI[5]  = _ibus[49];
assign \PROGDI[4]  = _ibus[48];
assign \PROGDI[3]  = _ibus[47];
assign \PROGDI[2]  = _ibus[46];
assign \PROGDI[1]  = _ibus[45];
assign \PROGDI[0]  = _ibus[44];
assign \XRAMDI[7]  = _ibus[43];
assign \XRAMDI[6]  = _ibus[42];
assign \XRAMDI[5]  = _ibus[41];
assign \XRAMDI[4]  = _ibus[40];
assign \XRAMDI[3]  = _ibus[39];
assign \XRAMDI[2]  = _ibus[38];
assign \XRAMDI[1]  = _ibus[37];
assign \XRAMDI[0]  = _ibus[36];
assign \SOURCE_DI[7]  = _ibus[35];
assign \SOURCE_DI[6]  = _ibus[34];
assign \SOURCE_DI[5]  = _ibus[33];
assign \SOURCE_DI[4]  = _ibus[32];
assign \SOURCE_DI[3]  = _ibus[31];
assign \SOURCE_DI[2]  = _ibus[30];
assign \SOURCE_DI[1]  = _ibus[29];
assign \SOURCE_DI[0]  = _ibus[28];
assign \ESFRDI[7]  = _ibus[27];
assign \ESFRDI[6]  = _ibus[26];
assign \ESFRDI[5]  = _ibus[25];
assign \ESFRDI[4]  = _ibus[24];
assign \ESFRDI[3]  = _ibus[23];
assign \ESFRDI[2]  = _ibus[22];
assign \ESFRDI[1]  = _ibus[21];
assign \ESFRDI[0]  = _ibus[20];
assign \XINTR_SRC[13]  = _ibus[19];
assign \XINTR_SRC[12]  = _ibus[18];
assign \XINTR_SRC[11]  = _ibus[17];
assign \XINTR_SRC[10]  = _ibus[16];
assign \XINTR_SRC[9]  = _ibus[15];
assign \XINTR_SRC[8]  = _ibus[14];
assign \XINTR_SRC[7]  = _ibus[13];
assign \XINTR_SRC[6]  = _ibus[12];
assign \XINTR_SRC[5]  = _ibus[11];
assign MWAIT = _ibus[10];
assign CLK1 = _ibus[9];
assign CLK2 = _ibus[8];
assign CLK3 = _ibus[7];
assign RESET = _ibus[6];
assign TRESET = _ibus[5];
assign scan_in1 = _ibus[4];
assign scan_in2 = _ibus[3];
assign scan_in3 = _ibus[2];
assign scan_in4 = _ibus[1];
assign scan_en = _ibus[0];

assign _sim_obus[148] = \PORT0O[7] ;
assign _sim_obus[147] = \PORT0O[6] ;
assign _sim_obus[146] = \PORT0O[5] ;
assign _sim_obus[145] = \PORT0O[4] ;
assign _sim_obus[144] = \PORT0O[3] ;
assign _sim_obus[143] = \PORT0O[2] ;
assign _sim_obus[142] = \PORT0O[1] ;
assign _sim_obus[141] = \PORT0O[0] ;
assign _sim_obus[140] = \PORT1O[7] ;
assign _sim_obus[139] = \PORT1O[6] ;
assign _sim_obus[138] = \PORT1O[5] ;
assign _sim_obus[137] = \PORT1O[4] ;
assign _sim_obus[136] = \PORT1O[3] ;
assign _sim_obus[135] = \PORT1O[2] ;
assign _sim_obus[134] = \PORT1O[1] ;
assign _sim_obus[133] = \PORT1O[0] ;
assign _sim_obus[132] = \PORT2O[7] ;
assign _sim_obus[131] = \PORT2O[6] ;
assign _sim_obus[130] = \PORT2O[5] ;
assign _sim_obus[129] = \PORT2O[4] ;
assign _sim_obus[128] = \PORT2O[3] ;
assign _sim_obus[127] = \PORT2O[2] ;
assign _sim_obus[126] = \PORT2O[1] ;
assign _sim_obus[125] = \PORT2O[0] ;
assign _sim_obus[124] = \PORT3O[7] ;
assign _sim_obus[123] = \PORT3O[6] ;
assign _sim_obus[122] = \PORT3O[5] ;
assign _sim_obus[121] = \PORT3O[4] ;
assign _sim_obus[120] = \PORT3O[3] ;
assign _sim_obus[119] = \PORT3O[2] ;
assign _sim_obus[118] = \PORT3O[1] ;
assign _sim_obus[117] = \PORT3O[0] ;
assign _sim_obus[116] = \NPORT1E[7] ;
assign _sim_obus[115] = \NPORT1E[6] ;
assign _sim_obus[114] = \NPORT1E[5] ;
assign _sim_obus[113] = \NPORT1E[4] ;
assign _sim_obus[112] = \NPORT1E[3] ;
assign _sim_obus[111] = \NPORT1E[2] ;
assign _sim_obus[110] = \NPORT1E[1] ;
assign _sim_obus[109] = \NPORT1E[0] ;
assign _sim_obus[108] = \NPORT2E[7] ;
assign _sim_obus[107] = \NPORT2E[6] ;
assign _sim_obus[106] = \NPORT2E[5] ;
assign _sim_obus[105] = \NPORT2E[4] ;
assign _sim_obus[104] = \NPORT2E[3] ;
assign _sim_obus[103] = \NPORT2E[2] ;
assign _sim_obus[102] = \NPORT2E[1] ;
assign _sim_obus[101] = \NPORT2E[0] ;
assign _sim_obus[100] = \NPORT3E[7] ;
assign _sim_obus[99] = \NPORT3E[6] ;
assign _sim_obus[98] = \NPORT3E[5] ;
assign _sim_obus[97] = \NPORT3E[4] ;
assign _sim_obus[96] = \NPORT3E[3] ;
assign _sim_obus[95] = \NPORT3E[2] ;
assign _sim_obus[94] = \NPORT3E[1] ;
assign _sim_obus[93] = \NPORT3E[0] ;
assign _sim_obus[92] = \XRAMDO[7] ;
assign _sim_obus[91] = \XRAMDO[6] ;
assign _sim_obus[90] = \XRAMDO[5] ;
assign _sim_obus[89] = \XRAMDO[4] ;
assign _sim_obus[88] = \XRAMDO[3] ;
assign _sim_obus[87] = \XRAMDO[2] ;
assign _sim_obus[86] = \XRAMDO[1] ;
assign _sim_obus[85] = \XRAMDO[0] ;
assign _sim_obus[84] = \PROGA[15] ;
assign _sim_obus[83] = \PROGA[14] ;
assign _sim_obus[82] = \PROGA[13] ;
assign _sim_obus[81] = \PROGA[12] ;
assign _sim_obus[80] = \PROGA[11] ;
assign _sim_obus[79] = \PROGA[10] ;
assign _sim_obus[78] = \PROGA[9] ;
assign _sim_obus[77] = \PROGA[8] ;
assign _sim_obus[76] = \PROGA[7] ;
assign _sim_obus[75] = \PROGA[6] ;
assign _sim_obus[74] = \PROGA[5] ;
assign _sim_obus[73] = \PROGA[4] ;
assign _sim_obus[72] = \PROGA[3] ;
assign _sim_obus[71] = \PROGA[2] ;
assign _sim_obus[70] = \PROGA[1] ;
assign _sim_obus[69] = \PROGA[0] ;
assign _sim_obus[68] = \XRAMA[15] ;
assign _sim_obus[67] = \XRAMA[14] ;
assign _sim_obus[66] = \XRAMA[13] ;
assign _sim_obus[65] = \XRAMA[12] ;
assign _sim_obus[64] = \XRAMA[11] ;
assign _sim_obus[63] = \XRAMA[10] ;
assign _sim_obus[62] = \XRAMA[9] ;
assign _sim_obus[61] = \XRAMA[8] ;
assign _sim_obus[60] = \XRAMA[7] ;
assign _sim_obus[59] = \XRAMA[6] ;
assign _sim_obus[58] = \XRAMA[5] ;
assign _sim_obus[57] = \XRAMA[4] ;
assign _sim_obus[56] = \XRAMA[3] ;
assign _sim_obus[55] = \XRAMA[2] ;
assign _sim_obus[54] = \XRAMA[1] ;
assign _sim_obus[53] = \XRAMA[0] ;
assign _sim_obus[52] = NPSEN;
assign _sim_obus[51] = NXRAMR;
assign _sim_obus[50] = NXRAMW;
assign _sim_obus[49] = PROGA_EN;
assign _sim_obus[48] = XRAMA_EN;
assign _sim_obus[47] = \SOURCE_A[7] ;
assign _sim_obus[46] = \SOURCE_A[6] ;
assign _sim_obus[45] = \SOURCE_A[5] ;
assign _sim_obus[44] = \SOURCE_A[4] ;
assign _sim_obus[43] = \SOURCE_A[3] ;
assign _sim_obus[42] = \SOURCE_A[2] ;
assign _sim_obus[41] = \SOURCE_A[1] ;
assign _sim_obus[40] = \SOURCE_A[0] ;
assign _sim_obus[39] = \DESTIN_A[7] ;
assign _sim_obus[38] = \DESTIN_A[6] ;
assign _sim_obus[37] = \DESTIN_A[5] ;
assign _sim_obus[36] = \DESTIN_A[4] ;
assign _sim_obus[35] = \DESTIN_A[3] ;
assign _sim_obus[34] = \DESTIN_A[2] ;
assign _sim_obus[33] = \DESTIN_A[1] ;
assign _sim_obus[32] = \DESTIN_A[0] ;
assign _sim_obus[31] = \DESTIN_DO[7] ;
assign _sim_obus[30] = \DESTIN_DO[6] ;
assign _sim_obus[29] = \DESTIN_DO[5] ;
assign _sim_obus[28] = \DESTIN_DO[4] ;
assign _sim_obus[27] = \DESTIN_DO[3] ;
assign _sim_obus[26] = \DESTIN_DO[2] ;
assign _sim_obus[25] = \DESTIN_DO[1] ;
assign _sim_obus[24] = \DESTIN_DO[0] ;
assign _sim_obus[23] = NDESTIN_WE;
assign _sim_obus[22] = NSOURCE_RE;
assign _sim_obus[21] = SFRWE;
assign _sim_obus[20] = \SFRSA[6] ;
assign _sim_obus[19] = \SFRSA[5] ;
assign _sim_obus[18] = \SFRSA[4] ;
assign _sim_obus[17] = \SFRSA[3] ;
assign _sim_obus[16] = \SFRSA[2] ;
assign _sim_obus[15] = \SFRSA[1] ;
assign _sim_obus[14] = \SFRSA[0] ;
assign _sim_obus[13] = \XINTR_ACK[13] ;
assign _sim_obus[12] = \XINTR_ACK[12] ;
assign _sim_obus[11] = \XINTR_ACK[11] ;
assign _sim_obus[10] = \XINTR_ACK[10] ;
assign _sim_obus[9] = \XINTR_ACK[9] ;
assign _sim_obus[8] = \XINTR_ACK[8] ;
assign _sim_obus[7] = \XINTR_ACK[7] ;
assign _sim_obus[6] = \XINTR_ACK[6] ;
assign _sim_obus[5] = \XINTR_ACK[5] ;
assign _sim_obus[4] = IDLE;
assign _sim_obus[3] = PDOWN;
assign _sim_obus[2] = NCCLKE;
assign _sim_obus[1] = NPCLKE;
assign _sim_obus[0] = scan_out1;

reg[256*8:1]  _tmp_filename; 
reg[256*8:1]  _new_filename; 

reg [119:0] _nam_obus[148:0];
initial $readmemh("pat_stuck_ser.v.po.name",_nam_obus,148,0);


// Declare Wires for tracking Vector Type
reg[3:0] _MGCDFT_VECTYPE ;
reg mgcdft_test_setup, mgcdft_load_unload, mgcdft_shift,
     mgcdft_single_shift, mgcdft_shift_extra, 
     mgcdft_shadow_control, mgcdft_master_observe,
     mgcdft_shadow_observe, mgcdft_skew_load, 
     mgcdft_seq_transparent, mgcdft_launch_capture,
     mgcdft_clock_proc, mgcdft_test_end, mgcdft_unknown; 

event       set_vector_type;
always @(_MGCDFT_VECTYPE) begin
  assign mgcdft_test_setup      = 1'b0;
  assign mgcdft_load_unload     = 1'b0;
  assign mgcdft_shift           = 1'b0;
  assign mgcdft_single_shift    = 1'b0;
  assign mgcdft_shift_extra     = 1'b0;
  assign mgcdft_shadow_control  = 1'b0;
  assign mgcdft_master_observe  = 1'b0;
  assign mgcdft_shadow_observe  = 1'b0;
  assign mgcdft_skew_load       = 1'b0;
  assign mgcdft_seq_transparent = 1'b0;
  assign mgcdft_launch_capture  = 1'b0;
  assign mgcdft_clock_proc      = 1'b0;
  assign mgcdft_test_end        = 1'b0;
  assign mgcdft_unknown         = 1'b0;
  case (_MGCDFT_VECTYPE)
    4'b0001: begin
               assign mgcdft_test_setup      = 1'b1;
               _scan_shift_count = 0;
             end
    4'b0010: begin
               assign mgcdft_load_unload     = 1'b1;
               _scan_shift_count = 0;
             end
    4'b0011: begin
               assign mgcdft_shift           = 1'b1;
               if(!(_scan_shift_count)) begin
                 _scan_shift_count = 1;
               end
             end
    4'b0100: begin
               assign mgcdft_single_shift    = 1'b1;
               if(!(_scan_shift_count)) begin
                 _scan_shift_count = 1;
               end
             end
    4'b0101: begin
               assign mgcdft_shift_extra     = 1'b1;
               _scan_shift_count = 0;
             end
    4'b0110: begin
               assign mgcdft_shadow_control  = 1'b1;
               _scan_shift_count = 0;
             end
    4'b0111: begin
               assign mgcdft_master_observe  = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1000: begin
               assign mgcdft_shadow_observe  = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1001: begin
               assign mgcdft_skew_load       = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1010: begin
               assign mgcdft_seq_transparent = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1011: begin
               assign mgcdft_launch_capture  = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1101: begin
               assign mgcdft_clock_proc      = 1'b1;
               _scan_shift_count = 0;
             end
    4'b1111: begin
               assign mgcdft_test_end        = 1'b1;
               _scan_shift_count = 0;
             end
    4'b0000: begin
               assign mgcdft_unknown         = 1'b1;
               _scan_shift_count = 0;
             end
    default: begin
               assign mgcdft_unknown         = 1'b1;
               _scan_shift_count = 0;
             end
  endcase
end

event       compare_exp_sim_obus;
always @(compare_exp_sim_obus) begin
 _found_fail = 0;
 if (_do_compare) begin
  if (_exp_obus !== _sim_obus) begin
     for(_bit_count = 0;
         ((_bit_count < 149)&&(_found_fail==0));
          _bit_count =_bit_count +1) begin
        if ((_msk_obus[_bit_count] === 1'b1) &&
            (_exp_obus[_bit_count] !== _sim_obus[_bit_count])) begin
           _found_fail = 1;
        end
     end
  end
  if (_found_fail == 1) begin
    $write($time, "ns: Simulated response %b pattern %d cycle %d\n",_sim_obus,_pattern_count,_cycle_count);
    $write($time, "ns: Expected  response %b pattern %d cycle %d\n",_exp_obus,_pattern_count,_cycle_count);
     for(_bit_count = 0;
         ((_bit_count < 149)&&((_miscompare_limit==0)||(_compare_fail<=_miscompare_limit)));
          _bit_count =_bit_count +1) begin
      if ((_msk_obus[_bit_count] === 1'b1) &&
          (_exp_obus[_bit_count] !== _sim_obus[_bit_count])) begin
        $write($time, "ns: Mismatch at pin %d name %s, Simulated %b, Expected %b\n",_bit_count,_nam_obus[_bit_count],_sim_obus[_bit_count],_exp_obus[_bit_count]);
        if (_write_MASK_file == 0) begin
         if (_scan_shift_count != 0) begin 
            case (_bit_count) // Scan Chain Failure 
              0: begin
                   $write($time, "ns: Mismatch on chain: chain1 cell: %d\n", (_scan_shift_count-1));
               end
              4: begin
                   $write($time, "ns: Mismatch on chain: chain2 cell: %d\n", (_scan_shift_count-1));
               end
              14: begin
                   $write($time, "ns: Mismatch on chain: chain3 cell: %d\n", (_scan_shift_count-1));
               end
              116: begin
                   $write($time, "ns: Mismatch on chain: chain4 cell: %d\n", (_scan_shift_count-1));
               end
            endcase
          end // _scan_shift_count
        end
        if (_write_DIAG_file == 1) begin
          if (_DIAG_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v_%0d_%0d.fail",
                       _start_pat, _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v_%0d.fail",
                      _start_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v__%0d.fail",
                       _end_pat);
              _diag_file = $fopen(_tmp_filename);
            end
            else begin
              _diag_file = $fopen("pat_stuck_ser.v.fail");
            end
            $fwrite(_diag_file, "// This File is simulation generated (pat_stuck_ser.v)\n");
            $fwrite(_diag_file, "format cycle\n");
            $fwrite(_diag_file, " failures_begin\n");
            $fwrite(_diag_file, "//cycle_number  PO_name  expected_value  simulated_value  ");
            $fwrite(_diag_file, "pattern_id  chain_name  cell_number\n\n");
            _DIAG_file_header = 1;
          end
          if ((_pattern_count == _last_fail_pattern) && (_pattern_count == 0)) begin
             _fail_pattern_cnt = 1; 
          end
          if (_pattern_count > _last_fail_pattern) begin 
             _fail_pattern_cnt = _fail_pattern_cnt + 1;
             _last_fail_pattern = _pattern_count;
          end

          $fwrite(_diag_file, "%d  %s ", _cycle_count, _nam_obus[_bit_count]);
          case ( _exp_obus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, "            H"); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, "            L"); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, "            Z"); 
                  end
          endcase
          case ( _sim_obus[_bit_count] )
            1'b1: begin
                    $fwrite(_diag_file, " H  // Pattern %d ", _pattern_count); 
                  end
            1'b0: begin
                    $fwrite(_diag_file, " L  // Pattern %d ", _pattern_count); 
                  end
            1'bZ: begin
                    $fwrite(_diag_file, " Z  // Pattern %d ", _pattern_count); 
                  end
            1'bX: begin
                    $fwrite(_diag_file, " X  // Pattern %d ", _pattern_count); 
                  end
          endcase
         if (_scan_shift_count == 0) begin
                 $fwrite(_diag_file, "\n");
         end // EndIf  _ScanShift_count
         if (_scan_shift_count != 0) begin
          case (_bit_count) // Scan Chain Failure
            0: begin
                 $fwrite(_diag_file, "chain: chain1  cell: %d \n", (_scan_shift_count-1));
                end
            4: begin
                 $fwrite(_diag_file, "chain: chain2  cell: %d \n", (_scan_shift_count-1));
                end
            14: begin
                 $fwrite(_diag_file, "chain: chain3  cell: %d \n", (_scan_shift_count-1));
                end
            116: begin
                 $fwrite(_diag_file, "chain: chain4  cell: %d \n", (_scan_shift_count-1));
                end
          endcase
         end // EndIf  _ScanShift_count
        end // EndIf _write_DIAG_file
        if (_write_MASK_file == 1) begin
          if (_MASK_file_header == 0) begin
            if ((_start_pat > -1) && (_end_pat > -1)) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v_%0d_%0d.mask",
                       _start_pat, _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_start_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v_%0d.mask",
                      _start_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else if (_end_pat > -1) begin
              $sformat(_tmp_filename, "pat_stuck_ser.v__%0d.mask",
                       _end_pat);
              _mask_file = $fopen(_tmp_filename);
            end
            else begin
              _mask_file = $fopen("pat_stuck_ser.v.mask");
            end
            $fwrite(_mask_file, "%s\n%s\n", "type mask", "");
            _MASK_file_header = 1;
          end
        _wrote_fail = 0;
         if (_scan_shift_count != 0) begin 
          case (_bit_count) // Scan Chain Failure 
            0: begin
                 $write($time, "ns: Mismatch on chain: chain1 cell: %d\n", (_scan_shift_count-1));
                 if (_chain_test_ == 0) begin
                   $fwrite(_mask_file, "%d %s %d\n",
                             _pattern_count, "chain1", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
                 if (_chain_test_ == 1) begin
                   $fwrite(_mask_file, "// %d %s %d\n",
                    _pattern_count,"chain1", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
               end
            4: begin
                 $write($time, "ns: Mismatch on chain: chain2 cell: %d\n", (_scan_shift_count-1));
                 if (_chain_test_ == 0) begin
                   $fwrite(_mask_file, "%d %s %d\n",
                             _pattern_count, "chain2", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
                 if (_chain_test_ == 1) begin
                   $fwrite(_mask_file, "// %d %s %d\n",
                    _pattern_count,"chain2", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
               end
            14: begin
                 $write($time, "ns: Mismatch on chain: chain3 cell: %d\n", (_scan_shift_count-1));
                 if (_chain_test_ == 0) begin
                   $fwrite(_mask_file, "%d %s %d\n",
                             _pattern_count, "chain3", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
                 if (_chain_test_ == 1) begin
                   $fwrite(_mask_file, "// %d %s %d\n",
                    _pattern_count,"chain3", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
               end
            116: begin
                 $write($time, "ns: Mismatch on chain: chain4 cell: %d\n", (_scan_shift_count-1));
                 if (_chain_test_ == 0) begin
                   $fwrite(_mask_file, "%d %s %d\n",
                             _pattern_count, "chain4", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
                 if (_chain_test_ == 1) begin
                   $fwrite(_mask_file, "// %d %s %d\n",
                    _pattern_count,"chain4", (_scan_shift_count-1));
                   _wrote_fail = 1;
                 end
               end
          endcase
         end // _scan_shift_count 
          if (_wrote_fail == 0 )  begin // not Scan Chain Failure
            if (_chain_test_ == 0) begin
              $fwrite(_mask_file, "%d %s\n", _pattern_count,_nam_obus[_bit_count]);
            end
            if (_chain_test_ == 1) begin
              $fwrite(_mask_file, "// %d %s\n", _pattern_count,_nam_obus[_bit_count]);
            end
          end
        end// if MaskFile
      end
    end
    _compare_fail = _compare_fail + 1;
  end
 end // if _do_compare
end

`ifdef VCD
  initial begin
    $dumpfile("pat_stuck_ser.v.dump");
    $dumpvars;
  end
`endif

`ifdef UTVCD
  initial begin
    $dumpfile("pat_stuck_ser.v.dump");
    $vtDump;
    $dumpvars;
  end
`endif

`ifdef debussy
  initial begin
    $fsdbDumpfile("pat_stuck_ser.v.fsdb");
    $fsdbDumpvars;
  end
`endif

reg[390:0]     mem [0:929];
cpu cpu_inst (.PORT0I({\PORT0I[7]  , \PORT0I[6] 
     , \PORT0I[5] , \PORT0I[4] , \PORT0I[3] 
     , \PORT0I[2] , \PORT0I[1] , \PORT0I[0] 
     }),.PORT1I({\PORT1I[7]  , \PORT1I[6] 
     , \PORT1I[5] , \PORT1I[4] , \PORT1I[3] 
     , \PORT1I[2] , \PORT1I[1] , \PORT1I[0] 
     }),.PORT2I({\PORT2I[7]  , \PORT2I[6] 
     , \PORT2I[5] , \PORT2I[4] , \PORT2I[3] 
     , \PORT2I[2] , \PORT2I[1] , \PORT2I[0] 
     }),.PORT3I({\PORT3I[7]  , \PORT3I[6] 
     , \PORT3I[5] , \PORT3I[4] , \PORT3I[3] 
     , \PORT3I[2] , \PORT3I[1] , \PORT3I[0] 
     }),.PROGDI({\PROGDI[7]  , \PROGDI[6] 
     , \PROGDI[5] , \PROGDI[4] , \PROGDI[3] 
     , \PROGDI[2] , \PROGDI[1] , \PROGDI[0] 
     }),.XRAMDI({\XRAMDI[7]  , \XRAMDI[6] 
     , \XRAMDI[5] , \XRAMDI[4] , \XRAMDI[3] 
     , \XRAMDI[2] , \XRAMDI[1] , \XRAMDI[0] 
     }),.SOURCE_DI({\SOURCE_DI[7]  
     , \SOURCE_DI[6] , \SOURCE_DI[5] 
     , \SOURCE_DI[4] , \SOURCE_DI[3] 
     , \SOURCE_DI[2] , \SOURCE_DI[1] 
     , \SOURCE_DI[0] }),.ESFRDI({\ESFRDI[7]  
     , \ESFRDI[6] , \ESFRDI[5] , \ESFRDI[4] 
     , \ESFRDI[3] , \ESFRDI[2] , \ESFRDI[1] 
     , \ESFRDI[0] }),.XINTR_SRC({\XINTR_SRC[13]  
     , \XINTR_SRC[12] , \XINTR_SRC[11] 
     , \XINTR_SRC[10] , \XINTR_SRC[9] 
     , \XINTR_SRC[8] , \XINTR_SRC[7] 
     , \XINTR_SRC[6] , \XINTR_SRC[5]  }), .MWAIT(MWAIT), 
     .CLK1(CLK1), .CLK2(CLK2), .CLK3(CLK3), .RESET(RESET), 
     .TRESET(TRESET), .scan_in1(scan_in1), .scan_in2(scan_in2), 
     .scan_in3(scan_in3), .scan_in4(scan_in4), .scan_en(scan_en), 
     .PORT0O({\PORT0O[7] , \PORT0O[6] , \PORT0O[5] 
     , \PORT0O[4] , \PORT0O[3] , \PORT0O[2] 
     , \PORT0O[1] , \PORT0O[0] }), .PORT1O({\PORT1O[7] 
     , \PORT1O[6] , \PORT1O[5] , \PORT1O[4] 
     , \PORT1O[3] , \PORT1O[2] , \PORT1O[1] 
     , \PORT1O[0] }), .PORT2O({\PORT2O[7] , \PORT2O[6] 
     , \PORT2O[5] , \PORT2O[4] , \PORT2O[3] 
     , \PORT2O[2] , \PORT2O[1] , \PORT2O[0] 
     }), .PORT3O({\PORT3O[7] , \PORT3O[6] , \PORT3O[5] 
     , \PORT3O[4] , \PORT3O[3] , \PORT3O[2] 
     , \PORT3O[1] , \PORT3O[0] }), .NPORT1E({\NPORT1E[7] 
     , \NPORT1E[6] , \NPORT1E[5] , \NPORT1E[4] 
     , \NPORT1E[3] , \NPORT1E[2] , \NPORT1E[1] 
     , \NPORT1E[0] }), .NPORT2E({\NPORT2E[7] 
     , \NPORT2E[6] , \NPORT2E[5] , \NPORT2E[4] 
     , \NPORT2E[3] , \NPORT2E[2] , \NPORT2E[1] 
     , \NPORT2E[0] }), .NPORT3E({\NPORT3E[7] 
     , \NPORT3E[6] , \NPORT3E[5] , \NPORT3E[4] 
     , \NPORT3E[3] , \NPORT3E[2] , \NPORT3E[1] 
     , \NPORT3E[0] }), .XRAMDO({\XRAMDO[7] 
     , \XRAMDO[6] , \XRAMDO[5] , \XRAMDO[4] 
     , \XRAMDO[3] , \XRAMDO[2] , \XRAMDO[1] 
     , \XRAMDO[0] }), .PROGA({\PROGA[15] , \PROGA[14] 
     , \PROGA[13] , \PROGA[12] , \PROGA[11] 
     , \PROGA[10] , \PROGA[9] , \PROGA[8] , \PROGA[7] 
     , \PROGA[6] , \PROGA[5] , \PROGA[4] , \PROGA[3] 
     , \PROGA[2] , \PROGA[1] , \PROGA[0] }), .XRAMA({\XRAMA[15] 
     , \XRAMA[14] , \XRAMA[13] , \XRAMA[12] 
     , \XRAMA[11] , \XRAMA[10] , \XRAMA[9] , \XRAMA[8] 
     , \XRAMA[7] , \XRAMA[6] , \XRAMA[5] , \XRAMA[4] 
     , \XRAMA[3] , \XRAMA[2] , \XRAMA[1] , \XRAMA[0] 
     }), .NPSEN(NPSEN), .NXRAMR(NXRAMR), .NXRAMW(NXRAMW), 
     .PROGA_EN(PROGA_EN), .XRAMA_EN(XRAMA_EN), 
     .SOURCE_A({\SOURCE_A[7] , \SOURCE_A[6] 
     , \SOURCE_A[5] , \SOURCE_A[4] , \SOURCE_A[3] 
     , \SOURCE_A[2] , \SOURCE_A[1] , \SOURCE_A[0] 
     }), .DESTIN_A({\DESTIN_A[7] , \DESTIN_A[6] 
     , \DESTIN_A[5] , \DESTIN_A[4] , \DESTIN_A[3] 
     , \DESTIN_A[2] , \DESTIN_A[1] , \DESTIN_A[0] 
     }), .DESTIN_DO({\DESTIN_DO[7] , \DESTIN_DO[6] 
     , \DESTIN_DO[5] , \DESTIN_DO[4] , \DESTIN_DO[3] 
     , \DESTIN_DO[2] , \DESTIN_DO[1] , \DESTIN_DO[0] 
     }), .NDESTIN_WE(NDESTIN_WE), .NSOURCE_RE(NSOURCE_RE), 
     .SFRWE(SFRWE), .SFRSA({\SFRSA[6] , \SFRSA[5] 
     , \SFRSA[4] , \SFRSA[3] , \SFRSA[2] , \SFRSA[1] 
     , \SFRSA[0] }), .XINTR_ACK({\XINTR_ACK[13] 
     , \XINTR_ACK[12] , \XINTR_ACK[11] 
     , \XINTR_ACK[10] , \XINTR_ACK[9] 
     , \XINTR_ACK[8] , \XINTR_ACK[7] , \XINTR_ACK[6] 
     , \XINTR_ACK[5] }), .IDLE(IDLE), .PDOWN(PDOWN), 
     .NCCLKE(NCCLKE), .NPCLKE(NPCLKE), .scan_out1(scan_out1));

initial begin
_compare_fail = 0;
_pattern_count = 0;
_cycle_count = 0;
_save_cycle_count = 0;
_write_DIAG_file = 0; // change to 1, to generate file
_write_MASK_file = 0; // change to 1, to generate file
_wrote_fail = 0;
_DIAG_file_header = 0;
_diag_file = 0;
_diag_chain_header = 0;
_diag_scan_header = 0;
_fail_pattern_cnt = 0;
_last_fail_pattern = 0;
_MASK_file_header = 0;
_mask_file = 0;
_chain_test_ = 0;
_par_shift_cnt = 0;
_report_bit_cnt = 0;
// Limit # of miscompares before aborting simulation (non-zero)
_miscompare_limit = 0; 
_end_vec_file_ok = 0; 
_scan_shift_count = 0;
_run_testsetup  = 0;
_start_pat      = -1;
_end_pat        = -1;
_pat_num        = -1;
_in_range       = 1;
_do_compare     = 1;
_in_chaintest   = 0;

_skipped_patterns = 0;

_end_simulation   = 0;

if ($value$plusargs("STARTPAT=%d", _start_pat)) begin
  $display(" Found Start pattern number %d", _start_pat);
  _in_range = 0;
  _do_compare = 0;
end
if ($value$plusargs("ENDPAT=%d", _end_pat)) begin
  $display(" Found End pattern number   %d", _end_pat);
end

if ($value$plusargs("CHAINTEST=%d", _in_chaintest)) begin
  if (_in_chaintest) begin
    $display(" Found ChainTest identifier %d", _in_chaintest);
  end
end


// read vector config file
_config_file = $fopen("pat_stuck_ser.v.cfg", "r");
if (_config_file == 0) begin
  $display("ERROR: Couldn't open configuration file, simulation aborted\n");
  $finish;
end
_fstat = 0;
if (_start_pat != -1) begin
  if (_in_chaintest == 0) begin
  $display("BEGIN pattern read loop  Start pattern (%d) End pattern (%d)\n",
_start_pat,_end_pat);
  end
  else begin
  $display("BEGIN pattern read loop  Start chain pattern (%d) End chain pattern (%d)\n",
_start_pat,_end_pat);
  end
end
else if (_end_pat != -1) begin
  if (_in_chaintest == 0) begin
  $display("BEGIN pattern read loop  End pattern (%d)\n", _end_pat);
  end
  else begin
  $display("BEGIN pattern read loop  End chain pattern (%d)\n", _end_pat);
  end
end

// begin pattern read loop
while (!$feof(_config_file))
begin
         _fstat = $fscanf(_config_file, "%s", _vec_file_name);
         _fstat = $fscanf(_config_file, "%d", _max_index);
   if (_fstat != -1) begin
          $display("Loading %0s\n", _vec_file_name);
          $readmemb(_vec_file_name, mem, 0, _max_index);
         _end_vec_file_ok = 0;
   end
   else begin
     _max_index = -1;
   end
   _scan_index = 0;
   _repeat_count = 0;
   _message_index = 0;
   _save_index = 0;
   for (_index=0; _index <= _max_index; _index = _index+1)
   begin
      vect = mem[_index];
      _exp_obus=149'bXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;
      _msk_obus=149'b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000;
      _MGCDFT_VECTYPE = vect[3:0];
      _pat_type = vect[6:4];
      _tp_num = vect[7];
      //    Range Check
      if ((_start_pat != -1)&&
          ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
        if ((_pat_num == _start_pat) && !_in_range) begin
          _in_range = 1;
          _do_compare = 0;
          _pattern_count = (_pat_num - 1);
          if (_pattern_count < 0) begin
            _pattern_count = 0;
          end
        end
        if (_pat_num == (_start_pat + 1)) begin
          _do_compare = 1;
        end
      end

      if ((_end_pat != -1) && (_pattern_count > _end_pat) && 
          ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
         // simulation complete, exit
         _index = _max_index + 1;
         _end_vec_file_ok = 1;
         _end_simulation = 1;
      end
      if ((_in_range) || (_run_testsetup)) begin
      case (_pat_type)
         3'b000:  begin // end vector
            _index = _max_index + 1;
         end // end vector
         3'b001: ;// skip scan vector, handled by shift vector
         3'b010:  begin // broadside vector
            if (vect[8] == 1'b1) begin
               _pattern_count = _pattern_count + 1;
               _par_shift_cnt = 0;
              if ((!_do_compare) && (_pattern_count >= _start_pat)) begin
                _do_compare = 1;
              end
              if ((_end_pat != -1) && (_pattern_count > _end_pat) && 
                  ((!_chain_test_)||(_chain_test_ && _in_chaintest))) begin
                // simulation complete, exit
                _index = _max_index + 1;
                _end_vec_file_ok = 1;
                _end_simulation = 1;
                _in_range = 0;
              end
            end
            if (vect[8] === 1'bz) begin
               _pattern_count = 0;
               _par_shift_cnt = 0;
            end
            if(_scan_shift_count) begin
               _scan_shift_count = _scan_shift_count + 1;
            end
            case (_tp_num)
               1'b1: begin // timeplate 1 - gen_tp1
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;
                  _ibus[83:10] = vect[390:317];
                  _ibus[4:0] = vect[311:307];

                  #10; // 10 ns
                  _exp_obus[148:0] = vect[306:158];
                  _msk_obus[148:0] = vect[157:9];
                  #0;
                  ->compare_exp_sim_obus;
                  if ((_miscompare_limit)&&(_compare_fail>=_miscompare_limit)) begin
                    $display("ERROR: exceeded miscompare limit(%d), exiting simulation",_miscompare_limit);
                    _end_vec_file_ok = 1;
                      if (_DIAG_file_header == 1) begin
                         $fwrite(_diag_file, " failures_end\n");
                         $fwrite(_diag_file, " failure_buffer_limit_reached none\n");
                         if (_diag_scan_header==1) begin
                           $fwrite(_diag_file, "last_cycle_applied %d\n", (_cycle_count-1));
                         end
                         $fwrite(_diag_file, "total_cycles 923\n");
                         $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
                         $fwrite(_diag_file, " simulation_time=", $time, ";\n");
                         $fwrite(_diag_file, "failure_file_end\n");
                         $fclose(_diag_file);
                      end
                      $finish;
                  end

                  #10; // 20 ns
                  _ibus[9:5] = vect[316:312];

                  #10; // 30 ns
                  _ibus[9] = 1'b0;
                  _ibus[8] = 1'b0;
                  _ibus[7] = 1'b0;
                  _ibus[6] = 1'b0;
                  _ibus[5] = 1'b0;

                  #10; // 40 ns
               end // timeplate 1 - gen_tp1
               default: begin
                  $display("ERROR: corrupt timeplate number\n");
                  $finish;
               end
            endcase // _tp_num
            _cycle_count = _cycle_count + 1;
            _par_shift_cnt = 0;
         end // broadside vector
         3'b011:  begin // status message vector
            _message_index = vect[38:7];
            case (_message_index)
               0: begin
                  $display("Begin chain test\n");
                 _chain_test_ = 1;
                  _diag_chain_header = 0;
               end
               1: begin
                  $display("End chain test\n");
                 _chain_test_ = 0;
                  if (_diag_chain_header) begin
                    $fwrite(_diag_file, " last_cycle_applied %d\n", _cycle_count);
                  end
                  _diag_scan_header = 0;
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                        $display("Simulated chain pattern %d\n",_pat_num);
                    end
                  end
                  _pat_num = -1;
                  _pattern_count = 0;
                  if (_in_chaintest) begin
                    _index = _max_index + 1;
                    _end_vec_file_ok = 1;
                    _end_simulation = 1;
                    _in_range = 0;
                  end
               end
               2: begin
                  $display("Status update: simulated through pattern %d\n",_pattern_count);
               end
               3: begin
                  _end_vec_file_ok = 1;
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                      if (!_chain_test_) begin
                        $display("Simulated pattern %d\n",_pat_num);
                      end
                    end
                  end
               end
               4: begin // start of atpg pattern
                  if ((_start_pat > -1) || (_end_pat > -1)) begin
                    if (_pat_num > -1) begin
                      if (_chain_test_) begin
                        $display("Simulated chain pattern %d\n",_pat_num);
                      end
                      else begin
                        $display("Simulated pattern %d\n",_pat_num);
                      end
                    end
                  end
                  _pat_num = _pat_num + 1;
                  _run_testsetup  = 0;
               end
               default: begin
                  $display("ERROR: corrupt message index\n");
                  $finish;
               end
            endcase // _message_index
         end
         default: begin
            $display("ERROR: corrupt vector number\n");
            $finish;
         end
      endcase
   end // if in_range
      else begin
      case (_pat_type)  // _pat_type = vect[6:4]; 
         3'b011:  begin // status message vector
            _message_index = vect[38:7]; 
            case (_message_index)
               0: begin
                  _chain_test_ = 1;
                  _diag_chain_header = 0;
               end
               1: begin
                  if (_pat_num > -1) begin
                    $display("Skipped chain pattern %d\n",_pat_num);
                  end
                  _chain_test_ = 0;
                  _pat_num = -1;
                  if (_in_chaintest) begin
                    _index = _max_index + 1;
                    _end_vec_file_ok = 1;
                    _end_simulation = 1;
                    _in_range = 0;
                  end
               end
               3: begin 
                  _end_vec_file_ok = 1;
                  if (_pat_num > -1) begin
                    if (!_chain_test_) begin
                      $display("Skipped pattern %d\n",_pat_num);
                    end
                  end
               end
               4: begin // start of atpg pattern
                  if (_pat_num > -1) begin
                    if (!_chain_test_) begin
                      _skipped_patterns = _skipped_patterns + 1;
                    end
                  end
                  if (_pat_num > -1) begin
                    if (_chain_test_) begin
                      $display("Skipped chain pattern %d\n",_pat_num);
                    end
                    else begin
                      $display("Skipped pattern %d\n",_pat_num);
                    end
                  end
                  _pat_num = _pat_num + 1;
                  _run_testsetup  = 0;
               end
               default: begin
                  // Skip
               end
            endcase // _message_index
         end
         default: begin
            // Skip
         end
      endcase
      end // else !_in_range
   end // index loop
end // file_cnt loop
 if (_DIAG_file_header == 1) begin
    $fwrite(_diag_file, " failures_end\n");
    $fwrite(_diag_file, " failure_buffer_limit_reached none\n");
    if (_diag_scan_header==1) begin
      $fwrite(_diag_file, "last_cycle_applied %d\n", (_cycle_count-1));
    end
    $fwrite(_diag_file, "total_cycles 923\n");
    $fwrite(_diag_file, "// failing_patterns=%d simulated_patterns=%d", _fail_pattern_cnt, (_pattern_count+1));
    $fwrite(_diag_file, " simulation_time=", $time, ";\n");
    $fwrite(_diag_file, "failure_file_end\n");
    $fclose(_diag_file);
 end


#1;
if (_end_vec_file_ok == 0) begin
  $display("ERROR: Pattern file corrupted, simulation aborted\n");
end
if ((_end_vec_file_ok) && (_compare_fail == 0)) begin
   $display("No error between simulated and expected patterns\n");
end

#1;
$finish;
end
endmodule
